
/* ****************************************************************
 *        CADENCE                    Copyright (c) 2001-2018      *
 *                                   Cadence Design Systems, Inc. *
 *                                   All rights reserved.         *
 ******************************************************************
 *  The values calculated from this script are meant to be        *
 *  representative programmings.   The values may not reflect the *
 *  actual required programming for production use.   Please      *
 *  closely review all programmed values for technical accuracy   *
 *  before use in production parts.                               *
 ******************************************************************
 *                                                                 
 *   Module:         regconfig.h
 *   Documentation:  Register programming header file
 *
 ******************************************************************
 ******************************************************************
 * WARNING:  This file was automatically generated.  Manual
 * editing may result in undetermined behavior.
 ******************************************************************
 ******************************************************************/
// REL: sifive.shanghai.n1-VIC_DDR__20180206


//`timescale 10ps/10ps

// ********************************************************************
// Option: IP    : IP Mode                       = PHY
// Option: BL    : Burst Length                  = 16
// Option: CL    : CAS Latency                   = 14
// Option: MHZ   : Simulation MHz                = 800
// Option: AP    : Auto Precharge Mode     (0/1) = 0
// Option: DLLBP : DLL Bypass Mode         (0/1) = 0
// Option: HALF  : Half-Memory Support     (0/1) = 0
// Option: RDIMM : Registered Dimm Support (0/1) = 0
// Option: AL    : Additive Latency              = 0
// Option: PREAM : Preamble Support    (0/1/2/3) = 0
// Option: BOF   : Burst On the Fly        (0/1) = 0
// Option: WLS   : Write Latency Set       (0/1) = 0
// Option: TCK   : Simulation period in ns       = 
// Option: WRDBIEN : Write DBI Enable       (0/1) = 0
// Option: RDDBIEN : Read DBI Enable       (0/1) = 0
// Option: RDPSTMBLE : RD Postamble En      (0/1) = 0
// Option: WRPSTMBLE : WR Postamble En      (0/1) = 0
// Option: CRC : CRC En      (0/1) = 0
// Option: SOMA  : Memory-SOMA file(s)           = /proj/iprel/sifive.shanghai.n1-VIC_DDR/sifive.shanghai.n1-VIC_DDR__20180201/mcip/mem/sifive.shanghai.n1-VIC_DDR/memory/jedec_lpddr4_16gb_3200/memory.xml.sim
// Option: PL    : CA Parity Latency              = -1
// ********************************************************************
// Memory: jedec_lpddr4_16gb_3200
// ********************************************************************


#define               DENALI_PHY_0_DATA 0b00000000000000000000010011110000 // PHY_IO_PAD_DELAY_TIMING_BYPASS_0:RW:16:4:=0x00 PHY_CLK_WR_BYPASS_SLAVE_DELAY_0:RW:0:11:=0x04f0
#define               DENALI_PHY_1_DATA 0b00000000000000000000000000000000 // PHY_WRITE_PATH_LAT_ADD_BYPASS_0:RW:16:3:=0x00 PHY_CLK_WRDQS_SLAVE_DELAY_BYPASS_0:RW:0:10:=0x0000
#define               DENALI_PHY_2_DATA 0b00000001000000110000001000000000 // PHY_LP2_DQS_GATE_CLS_0:RW:24:4:=0x01 PHY_BYPASS_TWO_CYC_PREAMBLE_0:RW:16:2:=0x03 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_0:RW:0:10:=0x0200
#define               DENALI_PHY_3_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ2_SHIFT_0:RW:24:6:=0x00 PHY_SW_WRDQ1_SHIFT_0:RW:16:6:=0x00 PHY_SW_WRDQ0_SHIFT_0:RW:8:6:=0x00 PHY_CLK_BYPASS_OVERRIDE_0:RW:0:1:=0x00
#define               DENALI_PHY_4_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ6_SHIFT_0:RW:24:6:=0x00 PHY_SW_WRDQ5_SHIFT_0:RW:16:6:=0x00 PHY_SW_WRDQ4_SHIFT_0:RW:8:6:=0x00 PHY_SW_WRDQ3_SHIFT_0:RW:0:6:=0x00
#define               DENALI_PHY_5_DATA 0b00000011000000000000000000000000 // PHY_PER_RANK_CS_MAP_0:RW+:24:2:=0x03 PHY_SW_WRDQS_SHIFT_0:RW:16:4:=0x00 PHY_SW_WRDM_SHIFT_0:RW:8:6:=0x00 PHY_SW_WRDQ7_SHIFT_0:RW:0:6:=0x00
#define               DENALI_PHY_6_DATA 0b00000001000000000000000000000001 // PHY_LP4_BOOT_RDDATA_EN_DLY_0:RW:24:5:=0x01 PHY_LP4_BOOT_RDDATA_EN_IE_DLY_0:RW:16:2:=0x00 PHY_PER_CS_TRAINING_INDEX_0:RW+:8:1:=0x00 PHY_PER_CS_TRAINING_MULTICAST_EN_0:RW_D:0:1:=0x01
#define               DENALI_PHY_7_DATA 0b00000011000000000000010000000000 // PHY_LP4_BOOT_WRPATH_GATE_DISABLE_0:RW:24:2:=0x03 PHY_LP4_BOOT_RDDQS_LATENCY_ADJUST_0:RW:16:4:=0x00 PHY_LP4_BOOT_RPTR_UPDATE_0:RW:8:4:=0x04 PHY_LP4_BOOT_RDDATA_EN_TSEL_DLY_0:RW:0:5:=0x00
#define               DENALI_PHY_8_DATA 0b00000001000000000000000000000001 // PHY_LPBK_DFX_TIMEOUT_EN_0:RW:24:1:=0x01 PHY_LPBK_CONTROL_0:RW:8:9:=0x0000 PHY_LP4_BOOT_RDDATA_EN_OE_DLY_0:RW:0:5:=0x01
#define               DENALI_PHY_9_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_CONTROL_0:RW:0:32:=0x00000000
#define               DENALI_PHY_10_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_OBS_0:RD:0:28:=0x00000000
#define               DENALI_PHY_11_DATA 0b00000001000000000000000000000001 // PHY_PRBS_PATTERN_START_0:RW_D:24:7:=0x01 PHY_DDR4_DQ_IDLE_0:RW:8:9:=0x0000 PHY_PDA_MODE_EN_0:RW:0:1:=0x01
#define               DENALI_PHY_12_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_MULTI_PATT_RST_DISABLE_0:RW:24:1:=0x00 PHY_RDLVL_MULTI_PATT_ENABLE_0:RW:16:1:=0x00 PHY_PRBS_PATTERN_MASK_0:RW:0:9:=0x0000
#define               DENALI_PHY_13_DATA 0b00000000110000000000000000000100 // PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_0:RW:16:10:=0x00c0 PHY_VREF_TRAIN_OBS_0:RD:8:6:=0x00 PHY_VREF_INITIAL_STEPSIZE_0:RW:0:5:=0x04
#define               DENALI_PHY_14_DATA 0b00000000110011000000000000001000 // PHY_GATE_SMPL1_SLAVE_DELAY_0:RW:16:9:=0x00cc SC_PHY_SNAP_OBS_REGS_0:WR:8:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_0:RW:0:4:=0x08
#define               DENALI_PHY_15_DATA 0b00000000011001100000011000000001 // PHY_GATE_SMPL2_SLAVE_DELAY_0:RW:16:9:=0x0066 PHY_MEM_CLASS_0:RW:8:3:=0x06 PHY_LPDDR_0:RW:0:1:=0x01
#define               DENALI_PHY_16_DATA 0b00000000000000000000000000000011 // ON_FLY_GATE_ADJUST_EN_0:RW:0:2:=0x03
#define               DENALI_PHY_17_DATA 0b00000000000000000000000000000000 // PHY_GATE_TRACKING_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_18_DATA 0b00000000000000000000000000000001 // PHY_LP4_PST_AMBLE_0:RW:8:2:=0x00 PHY_DFI40_POLARITY_0:RW:0:1:=0x01
#define               DENALI_PHY_19_DATA 0b00000000000000001010101010101010 // PHY_RDLVL_PATT8_0:RW:0:32:=0x0000AAAA
#define               DENALI_PHY_20_DATA 0b00000000000000000101010101010101 // PHY_RDLVL_PATT9_0:RW:0:32:=0x00005555
#define               DENALI_PHY_21_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT10_0:RW:0:32:=0x0000B5B5
#define               DENALI_PHY_22_DATA 0b00000000000000000100101001001010 // PHY_RDLVL_PATT11_0:RW:0:32:=0x00004A4A
#define               DENALI_PHY_23_DATA 0b00000000000000000101011001010110 // PHY_RDLVL_PATT12_0:RW:0:32:=0x00005656
#define               DENALI_PHY_24_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT13_0:RW:0:32:=0x0000A9A9
#define               DENALI_PHY_25_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT14_0:RW:0:32:=0x0000A9A9
#define               DENALI_PHY_26_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT15_0:RW:0:32:=0x0000B5B5
#define               DENALI_PHY_27_DATA 0b00000000000000000000000000000000 // PHY_RDDQ_ENC_OBS_SELECT_0:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_0:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_0:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_0:RW:0:3:=0x00
#define               DENALI_PHY_28_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_SELECT_0:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_0:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_0:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_0:RW:0:4:=0x00
#define               DENALI_PHY_29_DATA 0b00001000000000000000000000000000 // PHY_WRLVL_CAPTURE_CNT_0:RW:24:6:=0x08 PHY_WRLVL_ALGO_0:RW:16:2:=0x00 SC_PHY_LVL_DEBUG_CONT_0:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_0:RW:0:1:=0x00
#define               DENALI_PHY_30_DATA 0b00000100000000000000000000001000 // PHY_GTLVL_UPDT_WAIT_CNT_0:RW:24:4:=0x04 PHY_GTLVL_CAPTURE_CNT_0:RW:16:6:=0x00 PHY_DQ_MASK_0:RW:8:8:=0x00 PHY_WRLVL_UPDT_WAIT_CNT_0:RW:0:4:=0x08
#define               DENALI_PHY_31_DATA 0b00000000000000000000010000001000 // PHY_RDLVL_RDDQS_DQ_OBS_SELECT_0:RW:24:5:=0x00 PHY_RDLVL_OP_MODE_0:RW:16:2:=0x00 PHY_RDLVL_UPDT_WAIT_CNT_0:RW:8:4:=0x04 PHY_RDLVL_CAPTURE_CNT_0:RW:0:6:=0x08
#define               DENALI_PHY_32_DATA 0b00000000111001001110010000000000 // PHY_RDLVL_DATA_SWIZZLE_0:RW:8:18:=0x00e4e4 PHY_RDLVL_DATA_MASK_0:RW:0:8:=0x00
#define               DENALI_PHY_33_DATA 0b00000000000001110001000000100000 // PHY_WDQLVL_PATT_0:RW:16:3:=0x07 PHY_WDQLVL_BURST_CNT_0:RW:8:6:=0x10 PHY_WDQLVL_CLK_JITTER_TOLERANCE_0:RW:0:8:=0x20
#define               DENALI_PHY_34_DATA 0b00000000000011000000000000100000 // PHY_WDQLVL_DQDM_OBS_SELECT_0:RW:24:4:=0x00 PHY_WDQLVL_UPDT_WAIT_CNT_0:RW:16:4:=0x0c PHY_WDQLVL_DQDM_SLV_DLY_JUMP_OFFSET_0:RW:0:11:=0x0020
#define               DENALI_PHY_35_DATA 0b00000000000000000000011000100000 // SC_PHY_WDQLVL_CLR_PREV_RESULTS_0:WR:16:1:=0x00 PHY_WDQLVL_DM_DLY_STEP_0:RW:8:4:=0x06 PHY_WDQLVL_DQ_SLV_DELTA_0:RW:0:8:=0x20
#define               DENALI_PHY_36_DATA 0b00000000000000000000000100000000 // PHY_WDQLVL_DATADM_MASK_0:RW:0:9:=0x0100
#define               DENALI_PHY_37_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT0_0:RW:0:32:=0x55555555
#define               DENALI_PHY_38_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT1_0:RW:0:32:=0xAAAAAAAA
#define               DENALI_PHY_39_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT2_0:RW:0:32:=0x55555555
#define               DENALI_PHY_40_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT3_0:RW:0:32:=0xAAAAAAAA
#define               DENALI_PHY_41_DATA 0b00000000000000000101010101010101 // PHY_NTP_MULT_TRAIN_0:RW:16:1:=0x00 PHY_USER_PATT4_0:RW:0:16:=0x5555
#define               DENALI_PHY_42_DATA 0b00000001000000000000000100000000 // PHY_NTP_PERIOD_THRESHOLD_0:RW:16:10:=0x0100 PHY_NTP_EARLY_THRESHOLD_0:RW:0:10:=0x0100
#define               DENALI_PHY_43_DATA 0b00000000100000000000000110000000 // PHY_NTP_PERIOD_THRESHOLD_MAX_0:RW:16:10:=0x0080 PHY_NTP_PERIOD_THRESHOLD_MIN_0:RW:0:10:=0x0180
#define               DENALI_PHY_44_DATA 0b00000000000000000000000000000001 // PHY_FIFO_PTR_OBS_0:RD:16:8:=0x00 SC_PHY_MANUAL_CLEAR_0:WR:8:6:=0x00 PHY_CALVL_VREF_DRIVING_SLICE_0:RW:0:1:=0x01
#define               DENALI_PHY_45_DATA 0b00000000000000000000000000000000 // PHY_LPBK_RESULT_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_46_DATA 0b00000000000000000000000000000000 // PHY_MASTER_DLY_LOCK_OBS_0:RD:16:11:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_0:RD:0:16:=0x0000
#define               DENALI_PHY_47_DATA 0b00000000000000000000000000000000 // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_0:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_0:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_0:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_0:RD:0:7:=0x00
#define               DENALI_PHY_48_DATA 0b00000000000000000000000000000000 // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_0:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_0:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_0:RD:0:11:=0x0000
#define               DENALI_PHY_49_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD0_DELAY_OBS_0:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_0:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_0:RD:0:8:=0x00
#define               DENALI_PHY_50_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD1_DELAY_OBS_0:RD:0:10:=0x0000
#define               DENALI_PHY_51_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_STATUS_OBS_0:RD:0:17:=0x000000
#define               DENALI_PHY_52_DATA 0b00000000000000000000000000000000 // PHY_GATE_SMPL2_SLV_DLY_ENC_OBS_0:RD:16:10:=0x0000 PHY_GATE_SMPL1_SLV_DLY_ENC_OBS_0:RD:0:10:=0x0000
#define               DENALI_PHY_53_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD0_DELAY_OBS_0:RD:16:14:=0x0000 PHY_WRLVL_ERROR_OBS_0:RD:0:16:=0x0000
#define               DENALI_PHY_54_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD1_DELAY_OBS_0:RD:0:14:=0x0000
#define               DENALI_PHY_55_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_STATUS_OBS_0:RD:0:18:=0x000000
#define               DENALI_PHY_56_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_0:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_0:RD:0:10:=0x0000
#define               DENALI_PHY_57_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_0:RD:0:2:=0x00
#define               DENALI_PHY_58_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_STATUS_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_59_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_DQDM_TE_DLY_OBS_0:RD:16:11:=0x0000 PHY_WDQLVL_DQDM_LE_DLY_OBS_0:RD:0:11:=0x0000
#define               DENALI_PHY_60_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_STATUS_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_61_DATA 0b00000000000000000000000000000000 // PHY_DDL_MODE_0:RW:0:31:=0x00000000
#define               DENALI_PHY_62_DATA 0b00000000000000000000000000000000 // PHY_DDL_MASK_0:RW:0:6:=0x00
#define               DENALI_PHY_63_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_64_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_MSTR_DLY_OBS_0:RD:0:32:=0x00000000
#define               DENALI_PHY_65_DATA 0b00000000000000000000000000000100 // PHY_RX_CAL_OVERRIDE_0:RW:24:1:=0x00 SC_PHY_RX_CAL_START_0:WR:16:1:=0x00 PHY_LP4_WDQS_OE_EXTEND_0:RW:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_0:RW:0:8:=0x04
#define               DENALI_PHY_66_DATA 0b00000000000000000000000000100000 // PHY_RX_CAL_DQ2_0:RW+:24:6:=0x00 PHY_RX_CAL_DQ1_0:RW+:16:6:=0x00 PHY_RX_CAL_DQ0_0:RW+:8:6:=0x00 PHY_RX_CAL_SAMPLE_WAIT_0:RW:0:8:=0x20
#define               DENALI_PHY_67_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_DQ6_0:RW+:24:6:=0x00 PHY_RX_CAL_DQ5_0:RW+:16:6:=0x00 PHY_RX_CAL_DQ4_0:RW+:8:6:=0x00 PHY_RX_CAL_DQ3_0:RW+:0:6:=0x00
#define               DENALI_PHY_68_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_FDBK_0:RW+:24:6:=0x00 PHY_RX_CAL_DQS_0:RW+:16:6:=0x00 PHY_RX_CAL_DM_0:RW+:8:6:=0x00 PHY_RX_CAL_DQ7_0:RW+:0:6:=0x00
#define               DENALI_PHY_69_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_LOCK_OBS_0:RD:16:9:=0x0000 PHY_RX_CAL_OBS_0:RD:0:11:=0x0000
#define               DENALI_PHY_70_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_COMP_VAL_0:RW:24:1:=0x00 PHY_RX_CAL_DIFF_ADJUST_0:RW:16:4:=0x00 PHY_RX_CAL_SE_ADJUST_0:RW:8:4:=0x00 PHY_RX_CAL_DISABLE_0:RW:0:1:=0x00
#define               DENALI_PHY_71_DATA 0b00000111111111110000000000000000 // PHY_PAD_RX_BIAS_EN_0:RW:16:11:=0x07ff PHY_RX_CAL_INDEX_MASK_0:RW:0:12:=0x0000
#define               DENALI_PHY_72_DATA 0b00100000000000001000000000001000 // PHY_DATA_DC_ADJUST_START_0:RW:24:6:=0x20 PHY_DATA_DC_WEIGHT_0:RW:16:2:=0x00 PHY_DATA_DC_CAL_TIMEOUT_0:RW:8:8:=0x80 PHY_DATA_DC_CAL_SAMPLE_WAIT_0:RW:0:8:=0x08
#define               DENALI_PHY_73_DATA 0b00000000000000000000100000010000 // PHY_DATA_DC_CAL_POLARITY_0:RW:24:1:=0x00 PHY_DATA_DC_ADJUST_DIRECT_0:RW:16:1:=0x00 PHY_DATA_DC_ADJUST_THRSHLD_0:RW:8:8:=0x08 PHY_DATA_DC_ADJUST_SAMPLE_CNT_0:RW:0:8:=0x10
#define               DENALI_PHY_74_DATA 0b00000000000001000000000100000000 // PHY_SLV_DLY_CTRL_GATE_DISABLE_0:RW_D:24:1:=0x00 PHY_FDBK_PWR_CTRL_0:RW:16:3:=0x04 PHY_DATA_DC_SW_RANK_0:RW+:8:2:=0x01 PHY_DATA_DC_CAL_START_0:RW+:0:1:=0x00
#define               DENALI_PHY_75_DATA 0b00000000000000000000000000000000 // PHY_SLICE_PWR_RDC_DISABLE_0:RW:16:1:=0x00 PHY_DCC_RXCAL_CTRL_GATE_DISABLE_0:RW_D:8:1:=0x00 PHY_RDPATH_GATE_DISABLE_0:RW_D:0:1:=0x00
#define               DENALI_PHY_76_DATA 0b00000001100010000000110000000001 // PHY_DQS_TSEL_ENABLE_0:RW+:24:3:=0x01 PHY_DQ_TSEL_SELECT_0:RW+:8:16:=0x880c PHY_DQ_TSEL_ENABLE_0:RW+:0:3:=0x01
#define               DENALI_PHY_77_DATA 0b00100000000000111000100000001100 // PHY_VREF_INITIAL_START_POINT_0:RW+:24:6:=0x20 PHY_TWO_CYC_PREAMBLE_0:RW+:16:2:=0x03 PHY_DQS_TSEL_SELECT_0:RW+:0:16:=0x880c
#define               DENALI_PHY_78_DATA 0b00100000000000000000000100100101 // PHY_NTP_WDQ_STEP_SIZE_0:RW+:24:8:=0x20 PHY_NTP_TRAIN_EN_0:RW+:16:1:=0x00 PHY_VREF_TRAINING_CTRL_0:RW+:8:2:=0x01 PHY_VREF_INITIAL_STOP_POINT_0:RW+:0:6:=0x25
#define               DENALI_PHY_79_DATA 0b00000111111111110000001000000000 // PHY_NTP_WDQ_STOP_0:RW+:16:11:=0x07FF PHY_NTP_WDQ_START_0:RW+:0:11:=0x0200
#define               DENALI_PHY_80_DATA 0b00000000000000000000000100000001 // PHY_PAD_RX_DCD_0_0:RW+:24:5:=0x00 PHY_PAD_TX_DCD_0:RW+:16:5:=0x00 PHY_FAST_LVL_EN_0:RW+:8:4:=0x01 PHY_NTP_WDQ_BIT_EN_0:RW+:0:8:=0x01
#define               DENALI_PHY_81_DATA 0b00000000000000000000000000000000 // PHY_PAD_RX_DCD_4_0:RW+:24:5:=0x00 PHY_PAD_RX_DCD_3_0:RW+:16:5:=0x00 PHY_PAD_RX_DCD_2_0:RW+:8:5:=0x00 PHY_PAD_RX_DCD_1_0:RW+:0:5:=0x00
#define               DENALI_PHY_82_DATA 0b00000000000000000000000000000000 // PHY_PAD_DM_RX_DCD_0:RW+:24:5:=0x00 PHY_PAD_RX_DCD_7_0:RW+:16:5:=0x00 PHY_PAD_RX_DCD_6_0:RW+:8:5:=0x00 PHY_PAD_RX_DCD_5_0:RW+:0:5:=0x00
#define               DENALI_PHY_83_DATA 0b00000000000000000000000000000000 // PHY_PAD_DSLICE_IO_CFG_0:RW+:16:6:=0x00 PHY_PAD_FDBK_RX_DCD_0:RW+:8:5:=0x00 PHY_PAD_DQS_RX_DCD_0:RW+:0:5:=0x00
#define               DENALI_PHY_84_DATA 0b00000000000000000000000000000000 // PHY_RDDQ1_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_RDDQ0_SLAVE_DELAY_0:RW+:0:10:=0x0000
#define               DENALI_PHY_85_DATA 0b00000000000000000000000000000000 // PHY_RDDQ3_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_RDDQ2_SLAVE_DELAY_0:RW+:0:10:=0x0000
#define               DENALI_PHY_86_DATA 0b00000000000000000000000000000000 // PHY_RDDQ5_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_RDDQ4_SLAVE_DELAY_0:RW+:0:10:=0x0000
#define               DENALI_PHY_87_DATA 0b00000000000000000000000000000000 // PHY_RDDQ7_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_RDDQ6_SLAVE_DELAY_0:RW+:0:10:=0x0000
#define               DENALI_PHY_88_DATA 0b00000000000000100000000000000000 // PHY_DATA_DC_CAL_CLK_SEL_0:RW+:16:3:=0x02 PHY_RDDM_SLAVE_DELAY_0:RW+:0:10:=0x0000
#define               DENALI_PHY_89_DATA 0b01010001010100010101000001010010 // PHY_DQS_OE_TIMING_0:RW+:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_0:RW+:16:8:=0x51 PHY_DQ_TSEL_RD_TIMING_0:RW+:8:8:=0x50 PHY_DQ_OE_TIMING_0:RW+:0:8:=0x52
#define               DENALI_PHY_90_DATA 0b00110001110000000110000000000000 // PHY_DQS_TSEL_WR_TIMING_0:RW+:24:8:=0x31 PHY_DQS_OE_RD_TIMING_0:RW+:16:8:=0xc0 PHY_DQS_TSEL_RD_TIMING_0:RW+:8:8:=0x60 PHY_IO_PAD_DELAY_TIMING_0:RW+:0:4:=0x00
#define               DENALI_PHY_91_DATA 0b00000011110111110000000000000100 // PHY_PAD_VREF_CTRL_DQ_0:RW+:16:10:=0x011f PHY_VREF_SETTING_TIME_0:RW+:0:16:=0x0004
#define               DENALI_PHY_92_DATA 0b00000000110000001100000000000001 // PHY_RDDATA_EN_IE_DLY_0:RW+:24:2:=0x00 PHY_DQS_IE_TIMING_0:RW+:16:8:=0xc0 PHY_DQ_IE_TIMING_0:RW+:8:8:=0xc0 PHY_PER_CS_TRAINING_EN_0:RW+:0:1:=0x01
#define               DENALI_PHY_93_DATA 0b00000010000000000000000000000000 // PHY_WDQLVL_RDDATA_EN_DLY_0:RW+:24:5:=0x02 PHY_WDQLVL_IE_ON_0:RW+:16:1:=0x00 PHY_DBI_MODE_0:RW+:8:2:=0x00 PHY_IE_MODE_0:RW+:0:2:=0x00
#define               DENALI_PHY_94_DATA 0b00000000000000100000000100000001 // PHY_SW_MASTER_MODE_0:RW+:24:4:=0x00 PHY_RDDATA_EN_OE_DLY_0:RW+:16:5:=0x02 PHY_RDDATA_EN_TSEL_DLY_0:RW+:8:5:=0x01 PHY_WDQLVL_RDDATA_EN_TSEL_DLY_0:RW+:0:5:=0x01
#define               DENALI_PHY_95_DATA 0b01000010000100000000000000010000 // PHY_MASTER_DELAY_WAIT_0:RW+:24:8:=0x42 PHY_MASTER_DELAY_STEP_0:RW+:16:6:=0x10 PHY_MASTER_DELAY_START_0:RW+:0:11:=0x0010
#define               DENALI_PHY_96_DATA 0b00000001000011000000010000111110 // PHY_WRLVL_DLY_FINE_STEP_0:RW+:24:4:=0x01 PHY_WRLVL_DLY_STEP_0:RW+:16:8:=0x0c PHY_RPTR_UPDATE_0:RW+:8:4:=0x04 PHY_MASTER_DELAY_HALF_MEASURE_0:RW+:0:8:=0x3e
#define               DENALI_PHY_97_DATA 0b00000000000011110000110000011011 // PHY_GTLVL_RESP_WAIT_CNT_0:RW+:16:5:=0x0f PHY_GTLVL_DLY_STEP_0:RW+:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_0:RW+:0:6:=0x1b
#define               DENALI_PHY_98_DATA 0b00000001000000000000000101000000 // PHY_GTLVL_FINAL_STEP_0:RW+:16:10:=0x0100 PHY_GTLVL_BACK_STEP_0:RW+:0:10:=0x0140
#define               DENALI_PHY_99_DATA 0b00000000011110100000000100100000 // PHY_WDQLVL_DM_SEARCH_RANGE_0:RW+:16:9:=0x007a PHY_WDQLVL_QTR_DLY_STEP_0:RW+:8:4:=0x01 PHY_WDQLVL_DLY_STEP_0:RW+:0:8:=0x20
#define              DENALI_PHY_100_DATA 0b00000000000000000000110000000000 // PHY_RDLVL_DLY_STEP_0:RW+:8:4:=0x0c PHY_TOGGLE_PRE_SUPPORT_0:RW+:0:1:=0x00
#define              DENALI_PHY_101_DATA 0b00000000000000000000000111001100 // PHY_RDLVL_MAX_EDGE_0:RW+:0:10:=0x01cc
#define              DENALI_PHY_102_DATA 0b00000000000000000000001000000000 // PHY_DATA_DC_INIT_DISABLE_0:RW+:16:2:=0x00 PHY_WRPATH_GATE_TIMING_0:RW+:8:3:=0x02 PHY_WRPATH_GATE_DISABLE_0:RW+:0:2:=0x00
#define              DENALI_PHY_103_DATA 0b00000010100000000000000000000000 // PHY_DATA_DC_DQ_INIT_SLV_DELAY_0:RW+:16:11:=0x0280 PHY_DATA_DC_DQS_INIT_SLV_DELAY_0:RW+:0:10:=0x0000
#define              DENALI_PHY_104_DATA 0b10000000100000000000000100000001 // PHY_DATA_DC_DM_CLK_DIFF_THRSHLD_0:RW+:24:8:=0x80 PHY_DATA_DC_DM_CLK_SE_THRSHLD_0:RW+:16:8:=0x80 PHY_DATA_DC_WDQLVL_ENABLE_0:RW+:8:1:=0x01 PHY_DATA_DC_WRLVL_ENABLE_0:RW+:0:1:=0x01
#define              DENALI_PHY_105_DATA 0b00000000000000000000000000000010 // PHY_RDDATA_EN_DLY_0:RW+:0:5:=0x02
#define              DENALI_PHY_106_DATA 0b01110110010101000011001000010000 // PHY_DQ_DM_SWIZZLE0_0:RW+:0:32:=0x76543210
#define              DENALI_PHY_107_DATA 0b00000000000000000000000000001000 // PHY_DQ_DM_SWIZZLE1_0:RW+:0:4:=0x08
#define              DENALI_PHY_108_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ1_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ0_SLAVE_DELAY_0:RW+:0:11:=0x0280
#define              DENALI_PHY_109_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ3_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_0:RW+:0:11:=0x0280
#define              DENALI_PHY_110_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ5_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_0:RW+:0:11:=0x0280
#define              DENALI_PHY_111_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ7_SLAVE_DELAY_0:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_0:RW+:0:11:=0x0280
#define              DENALI_PHY_112_DATA 0b00000000000000000000001010000000 // PHY_CLK_WRDQS_SLAVE_DELAY_0:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_0:RW+:0:11:=0x0280
#define              DENALI_PHY_113_DATA 0b00000000000000001000000000000000 // PHY_RDDQS_DQ0_RISE_SLAVE_DELAY_0:RW+:8:10:=0x0080 PHY_WRLVL_THRESHOLD_ADJUST_0:RW+:0:2:=0x00
#define              DENALI_PHY_114_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ1_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ0_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_115_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ1_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_116_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_117_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_118_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_119_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_120_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_121_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DM_RISE_SLAVE_DELAY_0:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_122_DATA 0b00000001000110010000000010000000 // PHY_RDDQS_GATE_SLAVE_DELAY_0:RW+:16:10:=0x0119 PHY_RDDQS_DM_FALL_SLAVE_DELAY_0:RW+:0:10:=0x0080
#define              DENALI_PHY_123_DATA 0b00000001101000000000000000000010 // PHY_WRLVL_DELAY_EARLY_THRESHOLD_0:RW+:16:10:=0x01A0 PHY_WRITE_PATH_LAT_ADD_0:RW+:8:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_0:RW+:0:4:=0x02
#define              DENALI_PHY_124_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_EARLY_FORCE_ZERO_0:RW+:16:1:=0x00 PHY_WRLVL_DELAY_PERIOD_THRESHOLD_0:RW+:0:10:=0x0000
#define              DENALI_PHY_125_DATA 0b00000000000000100000000000000000 // PHY_GTLVL_LAT_ADJ_START_0:RW+:16:4:=0x02 PHY_GTLVL_RDDQS_SLV_DLY_START_0:RW+:0:10:=0x0000
#define              DENALI_PHY_126_DATA 0b00000000000010000000001000000000 // PHY_NTP_PASS_0:RW+:24:1:=0x00 PHY_NTP_WRLAT_START_0:RW+:16:4:=0x08 PHY_WDQLVL_DQDM_SLV_DLY_START_0:RW+:0:11:=0x0200
#define              DENALI_PHY_127_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_0:RW+:0:10:=0x0000
#define              DENALI_PHY_128_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ2_CLK_ADJUST_0:RW+:24:8:=0x20 PHY_DATA_DC_DQ1_CLK_ADJUST_0:RW+:16:8:=0x20 PHY_DATA_DC_DQ0_CLK_ADJUST_0:RW+:8:8:=0x20 PHY_DATA_DC_DQS_CLK_ADJUST_0:RW+:0:8:=0x20
#define              DENALI_PHY_129_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ6_CLK_ADJUST_0:RW+:24:8:=0x20 PHY_DATA_DC_DQ5_CLK_ADJUST_0:RW+:16:8:=0x20 PHY_DATA_DC_DQ4_CLK_ADJUST_0:RW+:8:8:=0x20 PHY_DATA_DC_DQ3_CLK_ADJUST_0:RW+:0:8:=0x20
#define              DENALI_PHY_130_DATA 0b00000000000000000010000000100000 // PHY_DSLICE_PAD_BOOSTPN_SETTING_0:RW+:16:16:=0x0000 PHY_DATA_DC_DM_CLK_ADJUST_0:RW+:8:8:=0x20 PHY_DATA_DC_DQ7_CLK_ADJUST_0:RW+:0:8:=0x20
#define              DENALI_PHY_131_DATA 0b00000000000000000000000000000000 // PHY_DSLICE_PAD_RX_CTLE_SETTING_0:RW+:0:4:=0x00
#define              DENALI_PHY_132_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_133_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_134_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_135_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_136_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_137_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_138_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_139_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_140_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_141_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_142_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_143_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_144_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_145_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_146_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_147_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_148_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_149_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_150_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_151_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_152_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_153_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_154_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_155_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_156_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_157_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_158_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_159_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_160_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_161_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_162_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_163_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_164_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_165_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_166_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_167_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_168_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_169_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_170_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_171_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_172_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_173_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_174_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_175_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_176_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_177_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_178_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_179_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_180_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_181_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_182_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_183_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_184_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_185_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_186_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_187_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_188_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_189_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_190_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_191_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_192_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_193_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_194_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_195_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_196_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_197_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_198_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_199_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_200_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_201_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_202_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_203_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_204_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_205_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_206_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_207_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_208_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_209_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_210_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_211_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_212_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_213_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_214_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_215_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_216_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_217_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_218_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_219_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_220_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_221_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_222_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_223_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_224_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_225_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_226_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_227_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_228_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_229_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_230_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_231_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_232_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_233_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_234_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_235_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_236_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_237_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_238_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_239_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_240_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_241_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_242_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_243_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_244_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_245_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_246_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_247_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_248_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_249_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_250_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_251_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_252_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_253_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_254_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_255_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_256_DATA 0b00000000000000000000010011110000 // PHY_IO_PAD_DELAY_TIMING_BYPASS_1:RW:16:4:=0x00 PHY_CLK_WR_BYPASS_SLAVE_DELAY_1:RW:0:11:=0x04f0
#define              DENALI_PHY_257_DATA 0b00000000000000000000000000000000 // PHY_WRITE_PATH_LAT_ADD_BYPASS_1:RW:16:3:=0x00 PHY_CLK_WRDQS_SLAVE_DELAY_BYPASS_1:RW:0:10:=0x0000
#define              DENALI_PHY_258_DATA 0b00000001000000110000001000000000 // PHY_LP2_DQS_GATE_CLS_1:RW:24:4:=0x01 PHY_BYPASS_TWO_CYC_PREAMBLE_1:RW:16:2:=0x03 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_1:RW:0:10:=0x0200
#define              DENALI_PHY_259_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ2_SHIFT_1:RW:24:6:=0x00 PHY_SW_WRDQ1_SHIFT_1:RW:16:6:=0x00 PHY_SW_WRDQ0_SHIFT_1:RW:8:6:=0x00 PHY_CLK_BYPASS_OVERRIDE_1:RW:0:1:=0x00
#define              DENALI_PHY_260_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ6_SHIFT_1:RW:24:6:=0x00 PHY_SW_WRDQ5_SHIFT_1:RW:16:6:=0x00 PHY_SW_WRDQ4_SHIFT_1:RW:8:6:=0x00 PHY_SW_WRDQ3_SHIFT_1:RW:0:6:=0x00
#define              DENALI_PHY_261_DATA 0b00000011000000000000000000000000 // PHY_PER_RANK_CS_MAP_1:RW+:24:2:=0x03 PHY_SW_WRDQS_SHIFT_1:RW:16:4:=0x00 PHY_SW_WRDM_SHIFT_1:RW:8:6:=0x00 PHY_SW_WRDQ7_SHIFT_1:RW:0:6:=0x00
#define              DENALI_PHY_262_DATA 0b00000001000000000000000000000001 // PHY_LP4_BOOT_RDDATA_EN_DLY_1:RW:24:5:=0x01 PHY_LP4_BOOT_RDDATA_EN_IE_DLY_1:RW:16:2:=0x00 PHY_PER_CS_TRAINING_INDEX_1:RW+:8:1:=0x00 PHY_PER_CS_TRAINING_MULTICAST_EN_1:RW_D:0:1:=0x01
#define              DENALI_PHY_263_DATA 0b00000011000000000000010000000000 // PHY_LP4_BOOT_WRPATH_GATE_DISABLE_1:RW:24:2:=0x03 PHY_LP4_BOOT_RDDQS_LATENCY_ADJUST_1:RW:16:4:=0x00 PHY_LP4_BOOT_RPTR_UPDATE_1:RW:8:4:=0x04 PHY_LP4_BOOT_RDDATA_EN_TSEL_DLY_1:RW:0:5:=0x00
#define              DENALI_PHY_264_DATA 0b00000001000000000000000000000001 // PHY_LPBK_DFX_TIMEOUT_EN_1:RW:24:1:=0x01 PHY_LPBK_CONTROL_1:RW:8:9:=0x0000 PHY_LP4_BOOT_RDDATA_EN_OE_DLY_1:RW:0:5:=0x01
#define              DENALI_PHY_265_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_CONTROL_1:RW:0:32:=0x00000000
#define              DENALI_PHY_266_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_OBS_1:RD:0:28:=0x00000000
#define              DENALI_PHY_267_DATA 0b00000001000000000000000000000001 // PHY_PRBS_PATTERN_START_1:RW_D:24:7:=0x01 PHY_DDR4_DQ_IDLE_1:RW:8:9:=0x0000 PHY_PDA_MODE_EN_1:RW:0:1:=0x01
#define              DENALI_PHY_268_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_MULTI_PATT_RST_DISABLE_1:RW:24:1:=0x00 PHY_RDLVL_MULTI_PATT_ENABLE_1:RW:16:1:=0x00 PHY_PRBS_PATTERN_MASK_1:RW:0:9:=0x0000
#define              DENALI_PHY_269_DATA 0b00000000110000000000000000000100 // PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_1:RW:16:10:=0x00c0 PHY_VREF_TRAIN_OBS_1:RD:8:6:=0x00 PHY_VREF_INITIAL_STEPSIZE_1:RW:0:5:=0x04
#define              DENALI_PHY_270_DATA 0b00000000110011000000000000001000 // PHY_GATE_SMPL1_SLAVE_DELAY_1:RW:16:9:=0x00cc SC_PHY_SNAP_OBS_REGS_1:WR:8:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_1:RW:0:4:=0x08
#define              DENALI_PHY_271_DATA 0b00000000011001100000011000000001 // PHY_GATE_SMPL2_SLAVE_DELAY_1:RW:16:9:=0x0066 PHY_MEM_CLASS_1:RW:8:3:=0x06 PHY_LPDDR_1:RW:0:1:=0x01
#define              DENALI_PHY_272_DATA 0b00000000000000000000000000000011 // ON_FLY_GATE_ADJUST_EN_1:RW:0:2:=0x03
#define              DENALI_PHY_273_DATA 0b00000000000000000000000000000000 // PHY_GATE_TRACKING_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_274_DATA 0b00000000000000000000000000000001 // PHY_LP4_PST_AMBLE_1:RW:8:2:=0x00 PHY_DFI40_POLARITY_1:RW:0:1:=0x01
#define              DENALI_PHY_275_DATA 0b00000000000000001010101010101010 // PHY_RDLVL_PATT8_1:RW:0:32:=0x0000AAAA
#define              DENALI_PHY_276_DATA 0b00000000000000000101010101010101 // PHY_RDLVL_PATT9_1:RW:0:32:=0x00005555
#define              DENALI_PHY_277_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT10_1:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_278_DATA 0b00000000000000000100101001001010 // PHY_RDLVL_PATT11_1:RW:0:32:=0x00004A4A
#define              DENALI_PHY_279_DATA 0b00000000000000000101011001010110 // PHY_RDLVL_PATT12_1:RW:0:32:=0x00005656
#define              DENALI_PHY_280_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT13_1:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_281_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT14_1:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_282_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT15_1:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_283_DATA 0b00000000000000000000000000000000 // PHY_RDDQ_ENC_OBS_SELECT_1:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_1:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_1:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_1:RW:0:3:=0x00
#define              DENALI_PHY_284_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_SELECT_1:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_1:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_1:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_1:RW:0:4:=0x00
#define              DENALI_PHY_285_DATA 0b00001000000000000000000000000000 // PHY_WRLVL_CAPTURE_CNT_1:RW:24:6:=0x08 PHY_WRLVL_ALGO_1:RW:16:2:=0x00 SC_PHY_LVL_DEBUG_CONT_1:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_1:RW:0:1:=0x00
#define              DENALI_PHY_286_DATA 0b00000100000000000000000000001000 // PHY_GTLVL_UPDT_WAIT_CNT_1:RW:24:4:=0x04 PHY_GTLVL_CAPTURE_CNT_1:RW:16:6:=0x00 PHY_DQ_MASK_1:RW:8:8:=0x00 PHY_WRLVL_UPDT_WAIT_CNT_1:RW:0:4:=0x08
#define              DENALI_PHY_287_DATA 0b00000000000000000000010000001000 // PHY_RDLVL_RDDQS_DQ_OBS_SELECT_1:RW:24:5:=0x00 PHY_RDLVL_OP_MODE_1:RW:16:2:=0x00 PHY_RDLVL_UPDT_WAIT_CNT_1:RW:8:4:=0x04 PHY_RDLVL_CAPTURE_CNT_1:RW:0:6:=0x08
#define              DENALI_PHY_288_DATA 0b00000000111001001110010000000000 // PHY_RDLVL_DATA_SWIZZLE_1:RW:8:18:=0x00e4e4 PHY_RDLVL_DATA_MASK_1:RW:0:8:=0x00
#define              DENALI_PHY_289_DATA 0b00000000000001110001000000100000 // PHY_WDQLVL_PATT_1:RW:16:3:=0x07 PHY_WDQLVL_BURST_CNT_1:RW:8:6:=0x10 PHY_WDQLVL_CLK_JITTER_TOLERANCE_1:RW:0:8:=0x20
#define              DENALI_PHY_290_DATA 0b00000000000011000000000000100000 // PHY_WDQLVL_DQDM_OBS_SELECT_1:RW:24:4:=0x00 PHY_WDQLVL_UPDT_WAIT_CNT_1:RW:16:4:=0x0c PHY_WDQLVL_DQDM_SLV_DLY_JUMP_OFFSET_1:RW:0:11:=0x0020
#define              DENALI_PHY_291_DATA 0b00000000000000000000011000100000 // SC_PHY_WDQLVL_CLR_PREV_RESULTS_1:WR:16:1:=0x00 PHY_WDQLVL_DM_DLY_STEP_1:RW:8:4:=0x06 PHY_WDQLVL_DQ_SLV_DELTA_1:RW:0:8:=0x20
#define              DENALI_PHY_292_DATA 0b00000000000000000000000100000000 // PHY_WDQLVL_DATADM_MASK_1:RW:0:9:=0x0100
#define              DENALI_PHY_293_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT0_1:RW:0:32:=0x55555555
#define              DENALI_PHY_294_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT1_1:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_295_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT2_1:RW:0:32:=0x55555555
#define              DENALI_PHY_296_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT3_1:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_297_DATA 0b00000000000000000101010101010101 // PHY_NTP_MULT_TRAIN_1:RW:16:1:=0x00 PHY_USER_PATT4_1:RW:0:16:=0x5555
#define              DENALI_PHY_298_DATA 0b00000001000000000000000100000000 // PHY_NTP_PERIOD_THRESHOLD_1:RW:16:10:=0x0100 PHY_NTP_EARLY_THRESHOLD_1:RW:0:10:=0x0100
#define              DENALI_PHY_299_DATA 0b00000000100000000000000110000000 // PHY_NTP_PERIOD_THRESHOLD_MAX_1:RW:16:10:=0x0080 PHY_NTP_PERIOD_THRESHOLD_MIN_1:RW:0:10:=0x0180
#define              DENALI_PHY_300_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_1:RD:16:8:=0x00 SC_PHY_MANUAL_CLEAR_1:WR:8:6:=0x00 PHY_CALVL_VREF_DRIVING_SLICE_1:RW:0:1:=0x00
#define              DENALI_PHY_301_DATA 0b00000000000000000000000000000000 // PHY_LPBK_RESULT_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_302_DATA 0b00000000000000000000000000000000 // PHY_MASTER_DLY_LOCK_OBS_1:RD:16:11:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_1:RD:0:16:=0x0000
#define              DENALI_PHY_303_DATA 0b00000000000000000000000000000000 // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_1:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_1:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_1:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_1:RD:0:7:=0x00
#define              DENALI_PHY_304_DATA 0b00000000000000000000000000000000 // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_1:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_1:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_1:RD:0:11:=0x0000
#define              DENALI_PHY_305_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD0_DELAY_OBS_1:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_1:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_1:RD:0:8:=0x00
#define              DENALI_PHY_306_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD1_DELAY_OBS_1:RD:0:10:=0x0000
#define              DENALI_PHY_307_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_STATUS_OBS_1:RD:0:17:=0x000000
#define              DENALI_PHY_308_DATA 0b00000000000000000000000000000000 // PHY_GATE_SMPL2_SLV_DLY_ENC_OBS_1:RD:16:10:=0x0000 PHY_GATE_SMPL1_SLV_DLY_ENC_OBS_1:RD:0:10:=0x0000
#define              DENALI_PHY_309_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD0_DELAY_OBS_1:RD:16:14:=0x0000 PHY_WRLVL_ERROR_OBS_1:RD:0:16:=0x0000
#define              DENALI_PHY_310_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD1_DELAY_OBS_1:RD:0:14:=0x0000
#define              DENALI_PHY_311_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_STATUS_OBS_1:RD:0:18:=0x000000
#define              DENALI_PHY_312_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_1:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_1:RD:0:10:=0x0000
#define              DENALI_PHY_313_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_1:RD:0:2:=0x00
#define              DENALI_PHY_314_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_STATUS_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_315_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_DQDM_TE_DLY_OBS_1:RD:16:11:=0x0000 PHY_WDQLVL_DQDM_LE_DLY_OBS_1:RD:0:11:=0x0000
#define              DENALI_PHY_316_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_STATUS_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_317_DATA 0b00000000000000000000000000000000 // PHY_DDL_MODE_1:RW:0:31:=0x00000000
#define              DENALI_PHY_318_DATA 0b00000000000000000000000000000000 // PHY_DDL_MASK_1:RW:0:6:=0x00
#define              DENALI_PHY_319_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_320_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_MSTR_DLY_OBS_1:RD:0:32:=0x00000000
#define              DENALI_PHY_321_DATA 0b00000000000000000000000000000100 // PHY_RX_CAL_OVERRIDE_1:RW:24:1:=0x00 SC_PHY_RX_CAL_START_1:WR:16:1:=0x00 PHY_LP4_WDQS_OE_EXTEND_1:RW:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_1:RW:0:8:=0x04
#define              DENALI_PHY_322_DATA 0b00000000000000000000000000100000 // PHY_RX_CAL_DQ2_1:RW+:24:6:=0x00 PHY_RX_CAL_DQ1_1:RW+:16:6:=0x00 PHY_RX_CAL_DQ0_1:RW+:8:6:=0x00 PHY_RX_CAL_SAMPLE_WAIT_1:RW:0:8:=0x20
#define              DENALI_PHY_323_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_DQ6_1:RW+:24:6:=0x00 PHY_RX_CAL_DQ5_1:RW+:16:6:=0x00 PHY_RX_CAL_DQ4_1:RW+:8:6:=0x00 PHY_RX_CAL_DQ3_1:RW+:0:6:=0x00
#define              DENALI_PHY_324_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_FDBK_1:RW+:24:6:=0x00 PHY_RX_CAL_DQS_1:RW+:16:6:=0x00 PHY_RX_CAL_DM_1:RW+:8:6:=0x00 PHY_RX_CAL_DQ7_1:RW+:0:6:=0x00
#define              DENALI_PHY_325_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_LOCK_OBS_1:RD:16:9:=0x0000 PHY_RX_CAL_OBS_1:RD:0:11:=0x0000
#define              DENALI_PHY_326_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_COMP_VAL_1:RW:24:1:=0x00 PHY_RX_CAL_DIFF_ADJUST_1:RW:16:4:=0x00 PHY_RX_CAL_SE_ADJUST_1:RW:8:4:=0x00 PHY_RX_CAL_DISABLE_1:RW:0:1:=0x00
#define              DENALI_PHY_327_DATA 0b00000111111111110000000000000000 // PHY_PAD_RX_BIAS_EN_1:RW:16:11:=0x07ff PHY_RX_CAL_INDEX_MASK_1:RW:0:12:=0x0000
#define              DENALI_PHY_328_DATA 0b00100000000000001000000000001000 // PHY_DATA_DC_ADJUST_START_1:RW:24:6:=0x20 PHY_DATA_DC_WEIGHT_1:RW:16:2:=0x00 PHY_DATA_DC_CAL_TIMEOUT_1:RW:8:8:=0x80 PHY_DATA_DC_CAL_SAMPLE_WAIT_1:RW:0:8:=0x08
#define              DENALI_PHY_329_DATA 0b00000000000000000000100000010000 // PHY_DATA_DC_CAL_POLARITY_1:RW:24:1:=0x00 PHY_DATA_DC_ADJUST_DIRECT_1:RW:16:1:=0x00 PHY_DATA_DC_ADJUST_THRSHLD_1:RW:8:8:=0x08 PHY_DATA_DC_ADJUST_SAMPLE_CNT_1:RW:0:8:=0x10
#define              DENALI_PHY_330_DATA 0b00000000000001000000000100000000 // PHY_SLV_DLY_CTRL_GATE_DISABLE_1:RW_D:24:1:=0x00 PHY_FDBK_PWR_CTRL_1:RW:16:3:=0x04 PHY_DATA_DC_SW_RANK_1:RW+:8:2:=0x01 PHY_DATA_DC_CAL_START_1:RW+:0:1:=0x00
#define              DENALI_PHY_331_DATA 0b00000000000000000000000000000000 // PHY_SLICE_PWR_RDC_DISABLE_1:RW:16:1:=0x00 PHY_DCC_RXCAL_CTRL_GATE_DISABLE_1:RW_D:8:1:=0x00 PHY_RDPATH_GATE_DISABLE_1:RW_D:0:1:=0x00
#define              DENALI_PHY_332_DATA 0b00000001100010000000110000000001 // PHY_DQS_TSEL_ENABLE_1:RW+:24:3:=0x01 PHY_DQ_TSEL_SELECT_1:RW+:8:16:=0x880c PHY_DQ_TSEL_ENABLE_1:RW+:0:3:=0x01
#define              DENALI_PHY_333_DATA 0b00100000000000111000100000001100 // PHY_VREF_INITIAL_START_POINT_1:RW+:24:6:=0x20 PHY_TWO_CYC_PREAMBLE_1:RW+:16:2:=0x03 PHY_DQS_TSEL_SELECT_1:RW+:0:16:=0x880c
#define              DENALI_PHY_334_DATA 0b00100000000000000000000100100101 // PHY_NTP_WDQ_STEP_SIZE_1:RW+:24:8:=0x20 PHY_NTP_TRAIN_EN_1:RW+:16:1:=0x00 PHY_VREF_TRAINING_CTRL_1:RW+:8:2:=0x01 PHY_VREF_INITIAL_STOP_POINT_1:RW+:0:6:=0x25
#define              DENALI_PHY_335_DATA 0b00000111111111110000001000000000 // PHY_NTP_WDQ_STOP_1:RW+:16:11:=0x07FF PHY_NTP_WDQ_START_1:RW+:0:11:=0x0200
#define              DENALI_PHY_336_DATA 0b00000000000000000000000100000001 // PHY_PAD_RX_DCD_0_1:RW+:24:5:=0x00 PHY_PAD_TX_DCD_1:RW+:16:5:=0x00 PHY_FAST_LVL_EN_1:RW+:8:4:=0x01 PHY_NTP_WDQ_BIT_EN_1:RW+:0:8:=0x01
#define              DENALI_PHY_337_DATA 0b00000000000000000000000000000000 // PHY_PAD_RX_DCD_4_1:RW+:24:5:=0x00 PHY_PAD_RX_DCD_3_1:RW+:16:5:=0x00 PHY_PAD_RX_DCD_2_1:RW+:8:5:=0x00 PHY_PAD_RX_DCD_1_1:RW+:0:5:=0x00
#define              DENALI_PHY_338_DATA 0b00000000000000000000000000000000 // PHY_PAD_DM_RX_DCD_1:RW+:24:5:=0x00 PHY_PAD_RX_DCD_7_1:RW+:16:5:=0x00 PHY_PAD_RX_DCD_6_1:RW+:8:5:=0x00 PHY_PAD_RX_DCD_5_1:RW+:0:5:=0x00
#define              DENALI_PHY_339_DATA 0b00000000000000000000000000000000 // PHY_PAD_DSLICE_IO_CFG_1:RW+:16:6:=0x00 PHY_PAD_FDBK_RX_DCD_1:RW+:8:5:=0x00 PHY_PAD_DQS_RX_DCD_1:RW+:0:5:=0x00
#define              DENALI_PHY_340_DATA 0b00000000000000000000000000000000 // PHY_RDDQ1_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_RDDQ0_SLAVE_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_341_DATA 0b00000000000000000000000000000000 // PHY_RDDQ3_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_RDDQ2_SLAVE_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_342_DATA 0b00000000000000000000000000000000 // PHY_RDDQ5_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_RDDQ4_SLAVE_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_343_DATA 0b00000000000000000000000000000000 // PHY_RDDQ7_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_RDDQ6_SLAVE_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_344_DATA 0b00000000000000100000000000000000 // PHY_DATA_DC_CAL_CLK_SEL_1:RW+:16:3:=0x02 PHY_RDDM_SLAVE_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_345_DATA 0b01010001010100010101000001010010 // PHY_DQS_OE_TIMING_1:RW+:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_1:RW+:16:8:=0x51 PHY_DQ_TSEL_RD_TIMING_1:RW+:8:8:=0x50 PHY_DQ_OE_TIMING_1:RW+:0:8:=0x52
#define              DENALI_PHY_346_DATA 0b00110001110000000110000000000000 // PHY_DQS_TSEL_WR_TIMING_1:RW+:24:8:=0x31 PHY_DQS_OE_RD_TIMING_1:RW+:16:8:=0xc0 PHY_DQS_TSEL_RD_TIMING_1:RW+:8:8:=0x60 PHY_IO_PAD_DELAY_TIMING_1:RW+:0:4:=0x00
#define              DENALI_PHY_347_DATA 0b00000011110111110000000000000100 // PHY_PAD_VREF_CTRL_DQ_1:RW+:16:10:=0x011f PHY_VREF_SETTING_TIME_1:RW+:0:16:=0x0004
#define              DENALI_PHY_348_DATA 0b00000000110000001100000000000001 // PHY_RDDATA_EN_IE_DLY_1:RW+:24:2:=0x00 PHY_DQS_IE_TIMING_1:RW+:16:8:=0xc0 PHY_DQ_IE_TIMING_1:RW+:8:8:=0xc0 PHY_PER_CS_TRAINING_EN_1:RW+:0:1:=0x01
#define              DENALI_PHY_349_DATA 0b00000010000000000000000000000000 // PHY_WDQLVL_RDDATA_EN_DLY_1:RW+:24:5:=0x02 PHY_WDQLVL_IE_ON_1:RW+:16:1:=0x00 PHY_DBI_MODE_1:RW+:8:2:=0x00 PHY_IE_MODE_1:RW+:0:2:=0x00
#define              DENALI_PHY_350_DATA 0b00000000000000100000000100000001 // PHY_SW_MASTER_MODE_1:RW+:24:4:=0x00 PHY_RDDATA_EN_OE_DLY_1:RW+:16:5:=0x02 PHY_RDDATA_EN_TSEL_DLY_1:RW+:8:5:=0x01 PHY_WDQLVL_RDDATA_EN_TSEL_DLY_1:RW+:0:5:=0x01
#define              DENALI_PHY_351_DATA 0b01000010000100000000000000010000 // PHY_MASTER_DELAY_WAIT_1:RW+:24:8:=0x42 PHY_MASTER_DELAY_STEP_1:RW+:16:6:=0x10 PHY_MASTER_DELAY_START_1:RW+:0:11:=0x0010
#define              DENALI_PHY_352_DATA 0b00000001000011000000010000111110 // PHY_WRLVL_DLY_FINE_STEP_1:RW+:24:4:=0x01 PHY_WRLVL_DLY_STEP_1:RW+:16:8:=0x0c PHY_RPTR_UPDATE_1:RW+:8:4:=0x04 PHY_MASTER_DELAY_HALF_MEASURE_1:RW+:0:8:=0x3e
#define              DENALI_PHY_353_DATA 0b00000000000011110000110000011011 // PHY_GTLVL_RESP_WAIT_CNT_1:RW+:16:5:=0x0f PHY_GTLVL_DLY_STEP_1:RW+:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_1:RW+:0:6:=0x1b
#define              DENALI_PHY_354_DATA 0b00000001000000000000000101000000 // PHY_GTLVL_FINAL_STEP_1:RW+:16:10:=0x0100 PHY_GTLVL_BACK_STEP_1:RW+:0:10:=0x0140
#define              DENALI_PHY_355_DATA 0b00000000011110100000000100100000 // PHY_WDQLVL_DM_SEARCH_RANGE_1:RW+:16:9:=0x007a PHY_WDQLVL_QTR_DLY_STEP_1:RW+:8:4:=0x01 PHY_WDQLVL_DLY_STEP_1:RW+:0:8:=0x20
#define              DENALI_PHY_356_DATA 0b00000000000000000000110000000000 // PHY_RDLVL_DLY_STEP_1:RW+:8:4:=0x0c PHY_TOGGLE_PRE_SUPPORT_1:RW+:0:1:=0x00
#define              DENALI_PHY_357_DATA 0b00000000000000000000000111001100 // PHY_RDLVL_MAX_EDGE_1:RW+:0:10:=0x01cc
#define              DENALI_PHY_358_DATA 0b00000000000000000000001000000000 // PHY_DATA_DC_INIT_DISABLE_1:RW+:16:2:=0x00 PHY_WRPATH_GATE_TIMING_1:RW+:8:3:=0x02 PHY_WRPATH_GATE_DISABLE_1:RW+:0:2:=0x00
#define              DENALI_PHY_359_DATA 0b00000010100000000000000000000000 // PHY_DATA_DC_DQ_INIT_SLV_DELAY_1:RW+:16:11:=0x0280 PHY_DATA_DC_DQS_INIT_SLV_DELAY_1:RW+:0:10:=0x0000
#define              DENALI_PHY_360_DATA 0b10000000100000000000000100000001 // PHY_DATA_DC_DM_CLK_DIFF_THRSHLD_1:RW+:24:8:=0x80 PHY_DATA_DC_DM_CLK_SE_THRSHLD_1:RW+:16:8:=0x80 PHY_DATA_DC_WDQLVL_ENABLE_1:RW+:8:1:=0x01 PHY_DATA_DC_WRLVL_ENABLE_1:RW+:0:1:=0x01
#define              DENALI_PHY_361_DATA 0b00000000000000000000000000000010 // PHY_RDDATA_EN_DLY_1:RW+:0:5:=0x02
#define              DENALI_PHY_362_DATA 0b01110110010101000011001000010000 // PHY_DQ_DM_SWIZZLE0_1:RW+:0:32:=0x76543210
#define              DENALI_PHY_363_DATA 0b00000000000000000000000000001000 // PHY_DQ_DM_SWIZZLE1_1:RW+:0:4:=0x08
#define              DENALI_PHY_364_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ1_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ0_SLAVE_DELAY_1:RW+:0:11:=0x0280
#define              DENALI_PHY_365_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ3_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_1:RW+:0:11:=0x0280
#define              DENALI_PHY_366_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ5_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_1:RW+:0:11:=0x0280
#define              DENALI_PHY_367_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ7_SLAVE_DELAY_1:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_1:RW+:0:11:=0x0280
#define              DENALI_PHY_368_DATA 0b00000000000000000000001010000000 // PHY_CLK_WRDQS_SLAVE_DELAY_1:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_1:RW+:0:11:=0x0280
#define              DENALI_PHY_369_DATA 0b00000000000000001000000000000000 // PHY_RDDQS_DQ0_RISE_SLAVE_DELAY_1:RW+:8:10:=0x0080 PHY_WRLVL_THRESHOLD_ADJUST_1:RW+:0:2:=0x00
#define              DENALI_PHY_370_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ1_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ0_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_371_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ1_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_372_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_373_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_374_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_375_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_376_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_377_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DM_RISE_SLAVE_DELAY_1:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_378_DATA 0b00000001000110010000000010000000 // PHY_RDDQS_GATE_SLAVE_DELAY_1:RW+:16:10:=0x0119 PHY_RDDQS_DM_FALL_SLAVE_DELAY_1:RW+:0:10:=0x0080
#define              DENALI_PHY_379_DATA 0b00000001101000000000000000000010 // PHY_WRLVL_DELAY_EARLY_THRESHOLD_1:RW+:16:10:=0x01A0 PHY_WRITE_PATH_LAT_ADD_1:RW+:8:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_1:RW+:0:4:=0x02
#define              DENALI_PHY_380_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_EARLY_FORCE_ZERO_1:RW+:16:1:=0x00 PHY_WRLVL_DELAY_PERIOD_THRESHOLD_1:RW+:0:10:=0x0000
#define              DENALI_PHY_381_DATA 0b00000000000000100000000000000000 // PHY_GTLVL_LAT_ADJ_START_1:RW+:16:4:=0x02 PHY_GTLVL_RDDQS_SLV_DLY_START_1:RW+:0:10:=0x0000
#define              DENALI_PHY_382_DATA 0b00000000000010000000001000000000 // PHY_NTP_PASS_1:RW+:24:1:=0x00 PHY_NTP_WRLAT_START_1:RW+:16:4:=0x08 PHY_WDQLVL_DQDM_SLV_DLY_START_1:RW+:0:11:=0x0200
#define              DENALI_PHY_383_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_1:RW+:0:10:=0x0000
#define              DENALI_PHY_384_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ2_CLK_ADJUST_1:RW+:24:8:=0x20 PHY_DATA_DC_DQ1_CLK_ADJUST_1:RW+:16:8:=0x20 PHY_DATA_DC_DQ0_CLK_ADJUST_1:RW+:8:8:=0x20 PHY_DATA_DC_DQS_CLK_ADJUST_1:RW+:0:8:=0x20
#define              DENALI_PHY_385_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ6_CLK_ADJUST_1:RW+:24:8:=0x20 PHY_DATA_DC_DQ5_CLK_ADJUST_1:RW+:16:8:=0x20 PHY_DATA_DC_DQ4_CLK_ADJUST_1:RW+:8:8:=0x20 PHY_DATA_DC_DQ3_CLK_ADJUST_1:RW+:0:8:=0x20
#define              DENALI_PHY_386_DATA 0b00000000000000000010000000100000 // PHY_DSLICE_PAD_BOOSTPN_SETTING_1:RW+:16:16:=0x0000 PHY_DATA_DC_DM_CLK_ADJUST_1:RW+:8:8:=0x20 PHY_DATA_DC_DQ7_CLK_ADJUST_1:RW+:0:8:=0x20
#define              DENALI_PHY_387_DATA 0b00000000000000000000000000000000 // PHY_DSLICE_PAD_RX_CTLE_SETTING_1:RW+:0:4:=0x00
#define              DENALI_PHY_388_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_389_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_390_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_391_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_392_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_393_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_394_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_395_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_396_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_397_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_398_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_399_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_400_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_401_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_402_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_403_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_404_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_405_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_406_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_407_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_408_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_409_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_410_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_411_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_412_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_413_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_414_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_415_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_416_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_417_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_418_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_419_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_420_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_421_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_422_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_423_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_424_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_425_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_426_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_427_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_428_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_429_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_430_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_431_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_432_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_433_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_434_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_435_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_436_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_437_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_438_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_439_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_440_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_441_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_442_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_443_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_444_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_445_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_446_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_447_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_448_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_449_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_450_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_451_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_452_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_453_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_454_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_455_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_456_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_457_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_458_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_459_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_460_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_461_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_462_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_463_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_464_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_465_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_466_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_467_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_468_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_469_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_470_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_471_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_472_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_473_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_474_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_475_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_476_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_477_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_478_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_479_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_480_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_481_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_482_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_483_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_484_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_485_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_486_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_487_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_488_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_489_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_490_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_491_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_492_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_493_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_494_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_495_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_496_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_497_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_498_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_499_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_500_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_501_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_502_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_503_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_504_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_505_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_506_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_507_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_508_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_509_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_510_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_511_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_512_DATA 0b00000000000000000000010011110000 // PHY_IO_PAD_DELAY_TIMING_BYPASS_2:RW:16:4:=0x00 PHY_CLK_WR_BYPASS_SLAVE_DELAY_2:RW:0:11:=0x04f0
#define              DENALI_PHY_513_DATA 0b00000000000000000000000000000000 // PHY_WRITE_PATH_LAT_ADD_BYPASS_2:RW:16:3:=0x00 PHY_CLK_WRDQS_SLAVE_DELAY_BYPASS_2:RW:0:10:=0x0000
#define              DENALI_PHY_514_DATA 0b00000001000000110000001000000000 // PHY_LP2_DQS_GATE_CLS_2:RW:24:4:=0x01 PHY_BYPASS_TWO_CYC_PREAMBLE_2:RW:16:2:=0x03 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_2:RW:0:10:=0x0200
#define              DENALI_PHY_515_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ2_SHIFT_2:RW:24:6:=0x00 PHY_SW_WRDQ1_SHIFT_2:RW:16:6:=0x00 PHY_SW_WRDQ0_SHIFT_2:RW:8:6:=0x00 PHY_CLK_BYPASS_OVERRIDE_2:RW:0:1:=0x00
#define              DENALI_PHY_516_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ6_SHIFT_2:RW:24:6:=0x00 PHY_SW_WRDQ5_SHIFT_2:RW:16:6:=0x00 PHY_SW_WRDQ4_SHIFT_2:RW:8:6:=0x00 PHY_SW_WRDQ3_SHIFT_2:RW:0:6:=0x00
#define              DENALI_PHY_517_DATA 0b00000011000000000000000000000000 // PHY_PER_RANK_CS_MAP_2:RW+:24:2:=0x03 PHY_SW_WRDQS_SHIFT_2:RW:16:4:=0x00 PHY_SW_WRDM_SHIFT_2:RW:8:6:=0x00 PHY_SW_WRDQ7_SHIFT_2:RW:0:6:=0x00
#define              DENALI_PHY_518_DATA 0b00000001000000000000000000000001 // PHY_LP4_BOOT_RDDATA_EN_DLY_2:RW:24:5:=0x01 PHY_LP4_BOOT_RDDATA_EN_IE_DLY_2:RW:16:2:=0x00 PHY_PER_CS_TRAINING_INDEX_2:RW+:8:1:=0x00 PHY_PER_CS_TRAINING_MULTICAST_EN_2:RW_D:0:1:=0x01
#define              DENALI_PHY_519_DATA 0b00000011000000000000010000000000 // PHY_LP4_BOOT_WRPATH_GATE_DISABLE_2:RW:24:2:=0x03 PHY_LP4_BOOT_RDDQS_LATENCY_ADJUST_2:RW:16:4:=0x00 PHY_LP4_BOOT_RPTR_UPDATE_2:RW:8:4:=0x04 PHY_LP4_BOOT_RDDATA_EN_TSEL_DLY_2:RW:0:5:=0x00
#define              DENALI_PHY_520_DATA 0b00000001000000000000000000000001 // PHY_LPBK_DFX_TIMEOUT_EN_2:RW:24:1:=0x01 PHY_LPBK_CONTROL_2:RW:8:9:=0x0000 PHY_LP4_BOOT_RDDATA_EN_OE_DLY_2:RW:0:5:=0x01
#define              DENALI_PHY_521_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_CONTROL_2:RW:0:32:=0x00000000
#define              DENALI_PHY_522_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_OBS_2:RD:0:28:=0x00000000
#define              DENALI_PHY_523_DATA 0b00000001000000000000000000000001 // PHY_PRBS_PATTERN_START_2:RW_D:24:7:=0x01 PHY_DDR4_DQ_IDLE_2:RW:8:9:=0x0000 PHY_PDA_MODE_EN_2:RW:0:1:=0x01
#define              DENALI_PHY_524_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_MULTI_PATT_RST_DISABLE_2:RW:24:1:=0x00 PHY_RDLVL_MULTI_PATT_ENABLE_2:RW:16:1:=0x00 PHY_PRBS_PATTERN_MASK_2:RW:0:9:=0x0000
#define              DENALI_PHY_525_DATA 0b00000000110000000000000000000100 // PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_2:RW:16:10:=0x00c0 PHY_VREF_TRAIN_OBS_2:RD:8:6:=0x00 PHY_VREF_INITIAL_STEPSIZE_2:RW:0:5:=0x04
#define              DENALI_PHY_526_DATA 0b00000000110011000000000000001000 // PHY_GATE_SMPL1_SLAVE_DELAY_2:RW:16:9:=0x00cc SC_PHY_SNAP_OBS_REGS_2:WR:8:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_2:RW:0:4:=0x08
#define              DENALI_PHY_527_DATA 0b00000000011001100000011000000001 // PHY_GATE_SMPL2_SLAVE_DELAY_2:RW:16:9:=0x0066 PHY_MEM_CLASS_2:RW:8:3:=0x06 PHY_LPDDR_2:RW:0:1:=0x01
#define              DENALI_PHY_528_DATA 0b00000000000000000000000000000011 // ON_FLY_GATE_ADJUST_EN_2:RW:0:2:=0x03
#define              DENALI_PHY_529_DATA 0b00000000000000000000000000000000 // PHY_GATE_TRACKING_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_530_DATA 0b00000000000000000000000000000001 // PHY_LP4_PST_AMBLE_2:RW:8:2:=0x00 PHY_DFI40_POLARITY_2:RW:0:1:=0x01
#define              DENALI_PHY_531_DATA 0b00000000000000001010101010101010 // PHY_RDLVL_PATT8_2:RW:0:32:=0x0000AAAA
#define              DENALI_PHY_532_DATA 0b00000000000000000101010101010101 // PHY_RDLVL_PATT9_2:RW:0:32:=0x00005555
#define              DENALI_PHY_533_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT10_2:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_534_DATA 0b00000000000000000100101001001010 // PHY_RDLVL_PATT11_2:RW:0:32:=0x00004A4A
#define              DENALI_PHY_535_DATA 0b00000000000000000101011001010110 // PHY_RDLVL_PATT12_2:RW:0:32:=0x00005656
#define              DENALI_PHY_536_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT13_2:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_537_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT14_2:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_538_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT15_2:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_539_DATA 0b00000000000000000000000000000000 // PHY_RDDQ_ENC_OBS_SELECT_2:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_2:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_2:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_2:RW:0:3:=0x00
#define              DENALI_PHY_540_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_SELECT_2:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_2:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_2:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_2:RW:0:4:=0x00
#define              DENALI_PHY_541_DATA 0b00001000000000000000000000000000 // PHY_WRLVL_CAPTURE_CNT_2:RW:24:6:=0x08 PHY_WRLVL_ALGO_2:RW:16:2:=0x00 SC_PHY_LVL_DEBUG_CONT_2:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_2:RW:0:1:=0x00
#define              DENALI_PHY_542_DATA 0b00000100000000000000000000001000 // PHY_GTLVL_UPDT_WAIT_CNT_2:RW:24:4:=0x04 PHY_GTLVL_CAPTURE_CNT_2:RW:16:6:=0x00 PHY_DQ_MASK_2:RW:8:8:=0x00 PHY_WRLVL_UPDT_WAIT_CNT_2:RW:0:4:=0x08
#define              DENALI_PHY_543_DATA 0b00000000000000000000010000001000 // PHY_RDLVL_RDDQS_DQ_OBS_SELECT_2:RW:24:5:=0x00 PHY_RDLVL_OP_MODE_2:RW:16:2:=0x00 PHY_RDLVL_UPDT_WAIT_CNT_2:RW:8:4:=0x04 PHY_RDLVL_CAPTURE_CNT_2:RW:0:6:=0x08
#define              DENALI_PHY_544_DATA 0b00000000111001001110010000000000 // PHY_RDLVL_DATA_SWIZZLE_2:RW:8:18:=0x00e4e4 PHY_RDLVL_DATA_MASK_2:RW:0:8:=0x00
#define              DENALI_PHY_545_DATA 0b00000000000001110001000000100000 // PHY_WDQLVL_PATT_2:RW:16:3:=0x07 PHY_WDQLVL_BURST_CNT_2:RW:8:6:=0x10 PHY_WDQLVL_CLK_JITTER_TOLERANCE_2:RW:0:8:=0x20
#define              DENALI_PHY_546_DATA 0b00000000000011000000000000100000 // PHY_WDQLVL_DQDM_OBS_SELECT_2:RW:24:4:=0x00 PHY_WDQLVL_UPDT_WAIT_CNT_2:RW:16:4:=0x0c PHY_WDQLVL_DQDM_SLV_DLY_JUMP_OFFSET_2:RW:0:11:=0x0020
#define              DENALI_PHY_547_DATA 0b00000000000000000000011000100000 // SC_PHY_WDQLVL_CLR_PREV_RESULTS_2:WR:16:1:=0x00 PHY_WDQLVL_DM_DLY_STEP_2:RW:8:4:=0x06 PHY_WDQLVL_DQ_SLV_DELTA_2:RW:0:8:=0x20
#define              DENALI_PHY_548_DATA 0b00000000000000000000000100000000 // PHY_WDQLVL_DATADM_MASK_2:RW:0:9:=0x0100
#define              DENALI_PHY_549_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT0_2:RW:0:32:=0x55555555
#define              DENALI_PHY_550_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT1_2:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_551_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT2_2:RW:0:32:=0x55555555
#define              DENALI_PHY_552_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT3_2:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_553_DATA 0b00000000000000000101010101010101 // PHY_NTP_MULT_TRAIN_2:RW:16:1:=0x00 PHY_USER_PATT4_2:RW:0:16:=0x5555
#define              DENALI_PHY_554_DATA 0b00000001000000000000000100000000 // PHY_NTP_PERIOD_THRESHOLD_2:RW:16:10:=0x0100 PHY_NTP_EARLY_THRESHOLD_2:RW:0:10:=0x0100
#define              DENALI_PHY_555_DATA 0b00000000100000000000000110000000 // PHY_NTP_PERIOD_THRESHOLD_MAX_2:RW:16:10:=0x0080 PHY_NTP_PERIOD_THRESHOLD_MIN_2:RW:0:10:=0x0180
#define              DENALI_PHY_556_DATA 0b00000000000000000000000000000001 // PHY_FIFO_PTR_OBS_2:RD:16:8:=0x00 SC_PHY_MANUAL_CLEAR_2:WR:8:6:=0x00 PHY_CALVL_VREF_DRIVING_SLICE_2:RW:0:1:=0x01
#define              DENALI_PHY_557_DATA 0b00000000000000000000000000000000 // PHY_LPBK_RESULT_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_558_DATA 0b00000000000000000000000000000000 // PHY_MASTER_DLY_LOCK_OBS_2:RD:16:11:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_2:RD:0:16:=0x0000
#define              DENALI_PHY_559_DATA 0b00000000000000000000000000000000 // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_2:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_2:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_2:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_2:RD:0:7:=0x00
#define              DENALI_PHY_560_DATA 0b00000000000000000000000000000000 // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_2:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_2:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_2:RD:0:11:=0x0000
#define              DENALI_PHY_561_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD0_DELAY_OBS_2:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_2:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_2:RD:0:8:=0x00
#define              DENALI_PHY_562_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD1_DELAY_OBS_2:RD:0:10:=0x0000
#define              DENALI_PHY_563_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_STATUS_OBS_2:RD:0:17:=0x000000
#define              DENALI_PHY_564_DATA 0b00000000000000000000000000000000 // PHY_GATE_SMPL2_SLV_DLY_ENC_OBS_2:RD:16:10:=0x0000 PHY_GATE_SMPL1_SLV_DLY_ENC_OBS_2:RD:0:10:=0x0000
#define              DENALI_PHY_565_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD0_DELAY_OBS_2:RD:16:14:=0x0000 PHY_WRLVL_ERROR_OBS_2:RD:0:16:=0x0000
#define              DENALI_PHY_566_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD1_DELAY_OBS_2:RD:0:14:=0x0000
#define              DENALI_PHY_567_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_STATUS_OBS_2:RD:0:18:=0x000000
#define              DENALI_PHY_568_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_2:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_2:RD:0:10:=0x0000
#define              DENALI_PHY_569_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_2:RD:0:2:=0x00
#define              DENALI_PHY_570_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_STATUS_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_571_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_DQDM_TE_DLY_OBS_2:RD:16:11:=0x0000 PHY_WDQLVL_DQDM_LE_DLY_OBS_2:RD:0:11:=0x0000
#define              DENALI_PHY_572_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_STATUS_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_573_DATA 0b00000000000000000000000000000000 // PHY_DDL_MODE_2:RW:0:31:=0x00000000
#define              DENALI_PHY_574_DATA 0b00000000000000000000000000000000 // PHY_DDL_MASK_2:RW:0:6:=0x00
#define              DENALI_PHY_575_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_576_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_MSTR_DLY_OBS_2:RD:0:32:=0x00000000
#define              DENALI_PHY_577_DATA 0b00000000000000000000000000000100 // PHY_RX_CAL_OVERRIDE_2:RW:24:1:=0x00 SC_PHY_RX_CAL_START_2:WR:16:1:=0x00 PHY_LP4_WDQS_OE_EXTEND_2:RW:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_2:RW:0:8:=0x04
#define              DENALI_PHY_578_DATA 0b00000000000000000000000000100000 // PHY_RX_CAL_DQ2_2:RW+:24:6:=0x00 PHY_RX_CAL_DQ1_2:RW+:16:6:=0x00 PHY_RX_CAL_DQ0_2:RW+:8:6:=0x00 PHY_RX_CAL_SAMPLE_WAIT_2:RW:0:8:=0x20
#define              DENALI_PHY_579_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_DQ6_2:RW+:24:6:=0x00 PHY_RX_CAL_DQ5_2:RW+:16:6:=0x00 PHY_RX_CAL_DQ4_2:RW+:8:6:=0x00 PHY_RX_CAL_DQ3_2:RW+:0:6:=0x00
#define              DENALI_PHY_580_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_FDBK_2:RW+:24:6:=0x00 PHY_RX_CAL_DQS_2:RW+:16:6:=0x00 PHY_RX_CAL_DM_2:RW+:8:6:=0x00 PHY_RX_CAL_DQ7_2:RW+:0:6:=0x00
#define              DENALI_PHY_581_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_LOCK_OBS_2:RD:16:9:=0x0000 PHY_RX_CAL_OBS_2:RD:0:11:=0x0000
#define              DENALI_PHY_582_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_COMP_VAL_2:RW:24:1:=0x00 PHY_RX_CAL_DIFF_ADJUST_2:RW:16:4:=0x00 PHY_RX_CAL_SE_ADJUST_2:RW:8:4:=0x00 PHY_RX_CAL_DISABLE_2:RW:0:1:=0x00
#define              DENALI_PHY_583_DATA 0b00000111111111110000000000000000 // PHY_PAD_RX_BIAS_EN_2:RW:16:11:=0x07ff PHY_RX_CAL_INDEX_MASK_2:RW:0:12:=0x0000
#define              DENALI_PHY_584_DATA 0b00100000000000001000000000001000 // PHY_DATA_DC_ADJUST_START_2:RW:24:6:=0x20 PHY_DATA_DC_WEIGHT_2:RW:16:2:=0x00 PHY_DATA_DC_CAL_TIMEOUT_2:RW:8:8:=0x80 PHY_DATA_DC_CAL_SAMPLE_WAIT_2:RW:0:8:=0x08
#define              DENALI_PHY_585_DATA 0b00000000000000000000100000010000 // PHY_DATA_DC_CAL_POLARITY_2:RW:24:1:=0x00 PHY_DATA_DC_ADJUST_DIRECT_2:RW:16:1:=0x00 PHY_DATA_DC_ADJUST_THRSHLD_2:RW:8:8:=0x08 PHY_DATA_DC_ADJUST_SAMPLE_CNT_2:RW:0:8:=0x10
#define              DENALI_PHY_586_DATA 0b00000000000001000000000100000000 // PHY_SLV_DLY_CTRL_GATE_DISABLE_2:RW_D:24:1:=0x00 PHY_FDBK_PWR_CTRL_2:RW:16:3:=0x04 PHY_DATA_DC_SW_RANK_2:RW+:8:2:=0x01 PHY_DATA_DC_CAL_START_2:RW+:0:1:=0x00
#define              DENALI_PHY_587_DATA 0b00000000000000000000000000000000 // PHY_SLICE_PWR_RDC_DISABLE_2:RW:16:1:=0x00 PHY_DCC_RXCAL_CTRL_GATE_DISABLE_2:RW_D:8:1:=0x00 PHY_RDPATH_GATE_DISABLE_2:RW_D:0:1:=0x00
#define              DENALI_PHY_588_DATA 0b00000001100010000000110000000001 // PHY_DQS_TSEL_ENABLE_2:RW+:24:3:=0x01 PHY_DQ_TSEL_SELECT_2:RW+:8:16:=0x880c PHY_DQ_TSEL_ENABLE_2:RW+:0:3:=0x01
#define              DENALI_PHY_589_DATA 0b00100000000000111000100000001100 // PHY_VREF_INITIAL_START_POINT_2:RW+:24:6:=0x20 PHY_TWO_CYC_PREAMBLE_2:RW+:16:2:=0x03 PHY_DQS_TSEL_SELECT_2:RW+:0:16:=0x880c
#define              DENALI_PHY_590_DATA 0b00100000000000000000000100100101 // PHY_NTP_WDQ_STEP_SIZE_2:RW+:24:8:=0x20 PHY_NTP_TRAIN_EN_2:RW+:16:1:=0x00 PHY_VREF_TRAINING_CTRL_2:RW+:8:2:=0x01 PHY_VREF_INITIAL_STOP_POINT_2:RW+:0:6:=0x25
#define              DENALI_PHY_591_DATA 0b00000111111111110000001000000000 // PHY_NTP_WDQ_STOP_2:RW+:16:11:=0x07FF PHY_NTP_WDQ_START_2:RW+:0:11:=0x0200
#define              DENALI_PHY_592_DATA 0b00000000000000000000000100000001 // PHY_PAD_RX_DCD_0_2:RW+:24:5:=0x00 PHY_PAD_TX_DCD_2:RW+:16:5:=0x00 PHY_FAST_LVL_EN_2:RW+:8:4:=0x01 PHY_NTP_WDQ_BIT_EN_2:RW+:0:8:=0x01
#define              DENALI_PHY_593_DATA 0b00000000000000000000000000000000 // PHY_PAD_RX_DCD_4_2:RW+:24:5:=0x00 PHY_PAD_RX_DCD_3_2:RW+:16:5:=0x00 PHY_PAD_RX_DCD_2_2:RW+:8:5:=0x00 PHY_PAD_RX_DCD_1_2:RW+:0:5:=0x00
#define              DENALI_PHY_594_DATA 0b00000000000000000000000000000000 // PHY_PAD_DM_RX_DCD_2:RW+:24:5:=0x00 PHY_PAD_RX_DCD_7_2:RW+:16:5:=0x00 PHY_PAD_RX_DCD_6_2:RW+:8:5:=0x00 PHY_PAD_RX_DCD_5_2:RW+:0:5:=0x00
#define              DENALI_PHY_595_DATA 0b00000000000000000000000000000000 // PHY_PAD_DSLICE_IO_CFG_2:RW+:16:6:=0x00 PHY_PAD_FDBK_RX_DCD_2:RW+:8:5:=0x00 PHY_PAD_DQS_RX_DCD_2:RW+:0:5:=0x00
#define              DENALI_PHY_596_DATA 0b00000000000000000000000000000000 // PHY_RDDQ1_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_RDDQ0_SLAVE_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_597_DATA 0b00000000000000000000000000000000 // PHY_RDDQ3_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_RDDQ2_SLAVE_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_598_DATA 0b00000000000000000000000000000000 // PHY_RDDQ5_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_RDDQ4_SLAVE_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_599_DATA 0b00000000000000000000000000000000 // PHY_RDDQ7_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_RDDQ6_SLAVE_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_600_DATA 0b00000000000000100000000000000000 // PHY_DATA_DC_CAL_CLK_SEL_2:RW+:16:3:=0x02 PHY_RDDM_SLAVE_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_601_DATA 0b01010001010100010101000001010010 // PHY_DQS_OE_TIMING_2:RW+:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_2:RW+:16:8:=0x51 PHY_DQ_TSEL_RD_TIMING_2:RW+:8:8:=0x50 PHY_DQ_OE_TIMING_2:RW+:0:8:=0x52
#define              DENALI_PHY_602_DATA 0b00110001110000000110000000000000 // PHY_DQS_TSEL_WR_TIMING_2:RW+:24:8:=0x31 PHY_DQS_OE_RD_TIMING_2:RW+:16:8:=0xc0 PHY_DQS_TSEL_RD_TIMING_2:RW+:8:8:=0x60 PHY_IO_PAD_DELAY_TIMING_2:RW+:0:4:=0x00
#define              DENALI_PHY_603_DATA 0b00000011110111110000000000000100 // PHY_PAD_VREF_CTRL_DQ_2:RW+:16:10:=0x011f PHY_VREF_SETTING_TIME_2:RW+:0:16:=0x0004
#define              DENALI_PHY_604_DATA 0b00000000110000001100000000000001 // PHY_RDDATA_EN_IE_DLY_2:RW+:24:2:=0x00 PHY_DQS_IE_TIMING_2:RW+:16:8:=0xc0 PHY_DQ_IE_TIMING_2:RW+:8:8:=0xc0 PHY_PER_CS_TRAINING_EN_2:RW+:0:1:=0x01
#define              DENALI_PHY_605_DATA 0b00000010000000000000000000000000 // PHY_WDQLVL_RDDATA_EN_DLY_2:RW+:24:5:=0x02 PHY_WDQLVL_IE_ON_2:RW+:16:1:=0x00 PHY_DBI_MODE_2:RW+:8:2:=0x00 PHY_IE_MODE_2:RW+:0:2:=0x00
#define              DENALI_PHY_606_DATA 0b00000000000000100000000100000001 // PHY_SW_MASTER_MODE_2:RW+:24:4:=0x00 PHY_RDDATA_EN_OE_DLY_2:RW+:16:5:=0x02 PHY_RDDATA_EN_TSEL_DLY_2:RW+:8:5:=0x01 PHY_WDQLVL_RDDATA_EN_TSEL_DLY_2:RW+:0:5:=0x01
#define              DENALI_PHY_607_DATA 0b01000010000100000000000000010000 // PHY_MASTER_DELAY_WAIT_2:RW+:24:8:=0x42 PHY_MASTER_DELAY_STEP_2:RW+:16:6:=0x10 PHY_MASTER_DELAY_START_2:RW+:0:11:=0x0010
#define              DENALI_PHY_608_DATA 0b00000001000011000000010000111110 // PHY_WRLVL_DLY_FINE_STEP_2:RW+:24:4:=0x01 PHY_WRLVL_DLY_STEP_2:RW+:16:8:=0x0c PHY_RPTR_UPDATE_2:RW+:8:4:=0x04 PHY_MASTER_DELAY_HALF_MEASURE_2:RW+:0:8:=0x3e
#define              DENALI_PHY_609_DATA 0b00000000000011110000110000011011 // PHY_GTLVL_RESP_WAIT_CNT_2:RW+:16:5:=0x0f PHY_GTLVL_DLY_STEP_2:RW+:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_2:RW+:0:6:=0x1b
#define              DENALI_PHY_610_DATA 0b00000001000000000000000101000000 // PHY_GTLVL_FINAL_STEP_2:RW+:16:10:=0x0100 PHY_GTLVL_BACK_STEP_2:RW+:0:10:=0x0140
#define              DENALI_PHY_611_DATA 0b00000000011110100000000100100000 // PHY_WDQLVL_DM_SEARCH_RANGE_2:RW+:16:9:=0x007a PHY_WDQLVL_QTR_DLY_STEP_2:RW+:8:4:=0x01 PHY_WDQLVL_DLY_STEP_2:RW+:0:8:=0x20
#define              DENALI_PHY_612_DATA 0b00000000000000000000110000000000 // PHY_RDLVL_DLY_STEP_2:RW+:8:4:=0x0c PHY_TOGGLE_PRE_SUPPORT_2:RW+:0:1:=0x00
#define              DENALI_PHY_613_DATA 0b00000000000000000000000111001100 // PHY_RDLVL_MAX_EDGE_2:RW+:0:10:=0x01cc
#define              DENALI_PHY_614_DATA 0b00000000000000000000001000000000 // PHY_DATA_DC_INIT_DISABLE_2:RW+:16:2:=0x00 PHY_WRPATH_GATE_TIMING_2:RW+:8:3:=0x02 PHY_WRPATH_GATE_DISABLE_2:RW+:0:2:=0x00
#define              DENALI_PHY_615_DATA 0b00000010100000000000000000000000 // PHY_DATA_DC_DQ_INIT_SLV_DELAY_2:RW+:16:11:=0x0280 PHY_DATA_DC_DQS_INIT_SLV_DELAY_2:RW+:0:10:=0x0000
#define              DENALI_PHY_616_DATA 0b10000000100000000000000100000001 // PHY_DATA_DC_DM_CLK_DIFF_THRSHLD_2:RW+:24:8:=0x80 PHY_DATA_DC_DM_CLK_SE_THRSHLD_2:RW+:16:8:=0x80 PHY_DATA_DC_WDQLVL_ENABLE_2:RW+:8:1:=0x01 PHY_DATA_DC_WRLVL_ENABLE_2:RW+:0:1:=0x01
#define              DENALI_PHY_617_DATA 0b00000000000000000000000000000010 // PHY_RDDATA_EN_DLY_2:RW+:0:5:=0x02
#define              DENALI_PHY_618_DATA 0b01110110010101000011001000010000 // PHY_DQ_DM_SWIZZLE0_2:RW+:0:32:=0x76543210
#define              DENALI_PHY_619_DATA 0b00000000000000000000000000001000 // PHY_DQ_DM_SWIZZLE1_2:RW+:0:4:=0x08
#define              DENALI_PHY_620_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ1_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ0_SLAVE_DELAY_2:RW+:0:11:=0x0280
#define              DENALI_PHY_621_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ3_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_2:RW+:0:11:=0x0280
#define              DENALI_PHY_622_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ5_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_2:RW+:0:11:=0x0280
#define              DENALI_PHY_623_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ7_SLAVE_DELAY_2:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_2:RW+:0:11:=0x0280
#define              DENALI_PHY_624_DATA 0b00000000000000000000001010000000 // PHY_CLK_WRDQS_SLAVE_DELAY_2:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_2:RW+:0:11:=0x0280
#define              DENALI_PHY_625_DATA 0b00000000000000001000000000000000 // PHY_RDDQS_DQ0_RISE_SLAVE_DELAY_2:RW+:8:10:=0x0080 PHY_WRLVL_THRESHOLD_ADJUST_2:RW+:0:2:=0x00
#define              DENALI_PHY_626_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ1_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ0_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_627_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ1_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_628_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_629_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_630_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_631_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_632_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_633_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DM_RISE_SLAVE_DELAY_2:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_634_DATA 0b00000001000110010000000010000000 // PHY_RDDQS_GATE_SLAVE_DELAY_2:RW+:16:10:=0x0119 PHY_RDDQS_DM_FALL_SLAVE_DELAY_2:RW+:0:10:=0x0080
#define              DENALI_PHY_635_DATA 0b00000001101000000000000000000010 // PHY_WRLVL_DELAY_EARLY_THRESHOLD_2:RW+:16:10:=0x01A0 PHY_WRITE_PATH_LAT_ADD_2:RW+:8:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_2:RW+:0:4:=0x02
#define              DENALI_PHY_636_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_EARLY_FORCE_ZERO_2:RW+:16:1:=0x00 PHY_WRLVL_DELAY_PERIOD_THRESHOLD_2:RW+:0:10:=0x0000
#define              DENALI_PHY_637_DATA 0b00000000000000100000000000000000 // PHY_GTLVL_LAT_ADJ_START_2:RW+:16:4:=0x02 PHY_GTLVL_RDDQS_SLV_DLY_START_2:RW+:0:10:=0x0000
#define              DENALI_PHY_638_DATA 0b00000000000010000000001000000000 // PHY_NTP_PASS_2:RW+:24:1:=0x00 PHY_NTP_WRLAT_START_2:RW+:16:4:=0x08 PHY_WDQLVL_DQDM_SLV_DLY_START_2:RW+:0:11:=0x0200
#define              DENALI_PHY_639_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_2:RW+:0:10:=0x0000
#define              DENALI_PHY_640_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ2_CLK_ADJUST_2:RW+:24:8:=0x20 PHY_DATA_DC_DQ1_CLK_ADJUST_2:RW+:16:8:=0x20 PHY_DATA_DC_DQ0_CLK_ADJUST_2:RW+:8:8:=0x20 PHY_DATA_DC_DQS_CLK_ADJUST_2:RW+:0:8:=0x20
#define              DENALI_PHY_641_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ6_CLK_ADJUST_2:RW+:24:8:=0x20 PHY_DATA_DC_DQ5_CLK_ADJUST_2:RW+:16:8:=0x20 PHY_DATA_DC_DQ4_CLK_ADJUST_2:RW+:8:8:=0x20 PHY_DATA_DC_DQ3_CLK_ADJUST_2:RW+:0:8:=0x20
#define              DENALI_PHY_642_DATA 0b00000000000000000010000000100000 // PHY_DSLICE_PAD_BOOSTPN_SETTING_2:RW+:16:16:=0x0000 PHY_DATA_DC_DM_CLK_ADJUST_2:RW+:8:8:=0x20 PHY_DATA_DC_DQ7_CLK_ADJUST_2:RW+:0:8:=0x20
#define              DENALI_PHY_643_DATA 0b00000000000000000000000000000000 // PHY_DSLICE_PAD_RX_CTLE_SETTING_2:RW+:0:4:=0x00
#define              DENALI_PHY_644_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_645_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_646_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_647_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_648_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_649_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_650_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_651_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_652_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_653_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_654_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_655_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_656_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_657_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_658_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_659_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_660_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_661_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_662_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_663_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_664_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_665_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_666_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_667_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_668_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_669_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_670_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_671_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_672_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_673_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_674_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_675_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_676_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_677_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_678_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_679_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_680_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_681_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_682_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_683_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_684_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_685_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_686_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_687_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_688_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_689_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_690_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_691_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_692_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_693_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_694_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_695_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_696_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_697_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_698_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_699_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_700_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_701_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_702_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_703_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_704_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_705_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_706_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_707_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_708_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_709_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_710_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_711_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_712_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_713_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_714_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_715_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_716_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_717_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_718_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_719_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_720_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_721_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_722_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_723_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_724_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_725_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_726_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_727_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_728_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_729_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_730_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_731_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_732_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_733_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_734_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_735_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_736_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_737_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_738_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_739_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_740_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_741_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_742_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_743_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_744_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_745_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_746_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_747_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_748_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_749_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_750_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_751_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_752_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_753_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_754_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_755_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_756_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_757_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_758_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_759_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_760_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_761_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_762_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_763_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_764_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_765_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_766_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_767_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_768_DATA 0b00000000000000000000010011110000 // PHY_IO_PAD_DELAY_TIMING_BYPASS_3:RW:16:4:=0x00 PHY_CLK_WR_BYPASS_SLAVE_DELAY_3:RW:0:11:=0x04f0
#define              DENALI_PHY_769_DATA 0b00000000000000000000000000000000 // PHY_WRITE_PATH_LAT_ADD_BYPASS_3:RW:16:3:=0x00 PHY_CLK_WRDQS_SLAVE_DELAY_BYPASS_3:RW:0:10:=0x0000
#define              DENALI_PHY_770_DATA 0b00000001000000110000001000000000 // PHY_LP2_DQS_GATE_CLS_3:RW:24:4:=0x01 PHY_BYPASS_TWO_CYC_PREAMBLE_3:RW:16:2:=0x03 PHY_RDDQS_GATE_BYPASS_SLAVE_DELAY_3:RW:0:10:=0x0200
#define              DENALI_PHY_771_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ2_SHIFT_3:RW:24:6:=0x00 PHY_SW_WRDQ1_SHIFT_3:RW:16:6:=0x00 PHY_SW_WRDQ0_SHIFT_3:RW:8:6:=0x00 PHY_CLK_BYPASS_OVERRIDE_3:RW:0:1:=0x00
#define              DENALI_PHY_772_DATA 0b00000000000000000000000000000000 // PHY_SW_WRDQ6_SHIFT_3:RW:24:6:=0x00 PHY_SW_WRDQ5_SHIFT_3:RW:16:6:=0x00 PHY_SW_WRDQ4_SHIFT_3:RW:8:6:=0x00 PHY_SW_WRDQ3_SHIFT_3:RW:0:6:=0x00
#define              DENALI_PHY_773_DATA 0b00000011000000000000000000000000 // PHY_PER_RANK_CS_MAP_3:RW+:24:2:=0x03 PHY_SW_WRDQS_SHIFT_3:RW:16:4:=0x00 PHY_SW_WRDM_SHIFT_3:RW:8:6:=0x00 PHY_SW_WRDQ7_SHIFT_3:RW:0:6:=0x00
#define              DENALI_PHY_774_DATA 0b00000001000000000000000000000001 // PHY_LP4_BOOT_RDDATA_EN_DLY_3:RW:24:5:=0x01 PHY_LP4_BOOT_RDDATA_EN_IE_DLY_3:RW:16:2:=0x00 PHY_PER_CS_TRAINING_INDEX_3:RW+:8:1:=0x00 PHY_PER_CS_TRAINING_MULTICAST_EN_3:RW_D:0:1:=0x01
#define              DENALI_PHY_775_DATA 0b00000011000000000000010000000000 // PHY_LP4_BOOT_WRPATH_GATE_DISABLE_3:RW:24:2:=0x03 PHY_LP4_BOOT_RDDQS_LATENCY_ADJUST_3:RW:16:4:=0x00 PHY_LP4_BOOT_RPTR_UPDATE_3:RW:8:4:=0x04 PHY_LP4_BOOT_RDDATA_EN_TSEL_DLY_3:RW:0:5:=0x00
#define              DENALI_PHY_776_DATA 0b00000001000000000000000000000001 // PHY_LPBK_DFX_TIMEOUT_EN_3:RW:24:1:=0x01 PHY_LPBK_CONTROL_3:RW:8:9:=0x0000 PHY_LP4_BOOT_RDDATA_EN_OE_DLY_3:RW:0:5:=0x01
#define              DENALI_PHY_777_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_CONTROL_3:RW:0:32:=0x00000000
#define              DENALI_PHY_778_DATA 0b00000000000000000000000000000000 // PHY_AUTO_TIMING_MARGIN_OBS_3:RD:0:28:=0x00000000
#define              DENALI_PHY_779_DATA 0b00000001000000000000000000000001 // PHY_PRBS_PATTERN_START_3:RW_D:24:7:=0x01 PHY_DDR4_DQ_IDLE_3:RW:8:9:=0x0000 PHY_PDA_MODE_EN_3:RW:0:1:=0x01
#define              DENALI_PHY_780_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_MULTI_PATT_RST_DISABLE_3:RW:24:1:=0x00 PHY_RDLVL_MULTI_PATT_ENABLE_3:RW:16:1:=0x00 PHY_PRBS_PATTERN_MASK_3:RW:0:9:=0x0000
#define              DENALI_PHY_781_DATA 0b00000000110000000000000000000100 // PHY_RDDQS_DQ_BYPASS_SLAVE_DELAY_3:RW:16:10:=0x00c0 PHY_VREF_TRAIN_OBS_3:RD:8:6:=0x00 PHY_VREF_INITIAL_STEPSIZE_3:RW:0:5:=0x04
#define              DENALI_PHY_782_DATA 0b00000000110011000000000000001000 // PHY_GATE_SMPL1_SLAVE_DELAY_3:RW:16:9:=0x00cc SC_PHY_SNAP_OBS_REGS_3:WR:8:1:=0x00 PHY_GATE_ERROR_DELAY_SELECT_3:RW:0:4:=0x08
#define              DENALI_PHY_783_DATA 0b00000000011001100000011000000001 // PHY_GATE_SMPL2_SLAVE_DELAY_3:RW:16:9:=0x0066 PHY_MEM_CLASS_3:RW:8:3:=0x06 PHY_LPDDR_3:RW:0:1:=0x01
#define              DENALI_PHY_784_DATA 0b00000000000000000000000000000011 // ON_FLY_GATE_ADJUST_EN_3:RW:0:2:=0x03
#define              DENALI_PHY_785_DATA 0b00000000000000000000000000000000 // PHY_GATE_TRACKING_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_786_DATA 0b00000000000000000000000000000001 // PHY_LP4_PST_AMBLE_3:RW:8:2:=0x00 PHY_DFI40_POLARITY_3:RW:0:1:=0x01
#define              DENALI_PHY_787_DATA 0b00000000000000001010101010101010 // PHY_RDLVL_PATT8_3:RW:0:32:=0x0000AAAA
#define              DENALI_PHY_788_DATA 0b00000000000000000101010101010101 // PHY_RDLVL_PATT9_3:RW:0:32:=0x00005555
#define              DENALI_PHY_789_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT10_3:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_790_DATA 0b00000000000000000100101001001010 // PHY_RDLVL_PATT11_3:RW:0:32:=0x00004A4A
#define              DENALI_PHY_791_DATA 0b00000000000000000101011001010110 // PHY_RDLVL_PATT12_3:RW:0:32:=0x00005656
#define              DENALI_PHY_792_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT13_3:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_793_DATA 0b00000000000000001010100110101001 // PHY_RDLVL_PATT14_3:RW:0:32:=0x0000A9A9
#define              DENALI_PHY_794_DATA 0b00000000000000001011010110110101 // PHY_RDLVL_PATT15_3:RW:0:32:=0x0000B5B5
#define              DENALI_PHY_795_DATA 0b00000000000000000000000000000000 // PHY_RDDQ_ENC_OBS_SELECT_3:RW:24:3:=0x00 PHY_MASTER_DLY_LOCK_OBS_SELECT_3:RW:16:4:=0x00 PHY_SW_FIFO_PTR_RST_DISABLE_3:RW:8:1:=0x00 PHY_SLAVE_LOOP_CNT_UPDATE_3:RW:0:3:=0x00
#define              DENALI_PHY_796_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_SELECT_3:RW:24:4:=0x00 PHY_WR_SHIFT_OBS_SELECT_3:RW:16:4:=0x00 PHY_WR_ENC_OBS_SELECT_3:RW:8:4:=0x00 PHY_RDDQS_DQ_ENC_OBS_SELECT_3:RW:0:4:=0x00
#define              DENALI_PHY_797_DATA 0b00001000000000000000000000000000 // PHY_WRLVL_CAPTURE_CNT_3:RW:24:6:=0x08 PHY_WRLVL_ALGO_3:RW:16:2:=0x00 SC_PHY_LVL_DEBUG_CONT_3:WR:8:1:=0x00 PHY_LVL_DEBUG_MODE_3:RW:0:1:=0x00
#define              DENALI_PHY_798_DATA 0b00000100000000000000000000001000 // PHY_GTLVL_UPDT_WAIT_CNT_3:RW:24:4:=0x04 PHY_GTLVL_CAPTURE_CNT_3:RW:16:6:=0x00 PHY_DQ_MASK_3:RW:8:8:=0x00 PHY_WRLVL_UPDT_WAIT_CNT_3:RW:0:4:=0x08
#define              DENALI_PHY_799_DATA 0b00000000000000000000010000001000 // PHY_RDLVL_RDDQS_DQ_OBS_SELECT_3:RW:24:5:=0x00 PHY_RDLVL_OP_MODE_3:RW:16:2:=0x00 PHY_RDLVL_UPDT_WAIT_CNT_3:RW:8:4:=0x04 PHY_RDLVL_CAPTURE_CNT_3:RW:0:6:=0x08
#define              DENALI_PHY_800_DATA 0b00000000111001001110010000000000 // PHY_RDLVL_DATA_SWIZZLE_3:RW:8:18:=0x00e4e4 PHY_RDLVL_DATA_MASK_3:RW:0:8:=0x00
#define              DENALI_PHY_801_DATA 0b00000000000001110001000000100000 // PHY_WDQLVL_PATT_3:RW:16:3:=0x07 PHY_WDQLVL_BURST_CNT_3:RW:8:6:=0x10 PHY_WDQLVL_CLK_JITTER_TOLERANCE_3:RW:0:8:=0x20
#define              DENALI_PHY_802_DATA 0b00000000000011000000000000100000 // PHY_WDQLVL_DQDM_OBS_SELECT_3:RW:24:4:=0x00 PHY_WDQLVL_UPDT_WAIT_CNT_3:RW:16:4:=0x0c PHY_WDQLVL_DQDM_SLV_DLY_JUMP_OFFSET_3:RW:0:11:=0x0020
#define              DENALI_PHY_803_DATA 0b00000000000000000000011000100000 // SC_PHY_WDQLVL_CLR_PREV_RESULTS_3:WR:16:1:=0x00 PHY_WDQLVL_DM_DLY_STEP_3:RW:8:4:=0x06 PHY_WDQLVL_DQ_SLV_DELTA_3:RW:0:8:=0x20
#define              DENALI_PHY_804_DATA 0b00000000000000000000000100000000 // PHY_WDQLVL_DATADM_MASK_3:RW:0:9:=0x0100
#define              DENALI_PHY_805_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT0_3:RW:0:32:=0x55555555
#define              DENALI_PHY_806_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT1_3:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_807_DATA 0b01010101010101010101010101010101 // PHY_USER_PATT2_3:RW:0:32:=0x55555555
#define              DENALI_PHY_808_DATA 0b10101010101010101010101010101010 // PHY_USER_PATT3_3:RW:0:32:=0xAAAAAAAA
#define              DENALI_PHY_809_DATA 0b00000000000000000101010101010101 // PHY_NTP_MULT_TRAIN_3:RW:16:1:=0x00 PHY_USER_PATT4_3:RW:0:16:=0x5555
#define              DENALI_PHY_810_DATA 0b00000001000000000000000100000000 // PHY_NTP_PERIOD_THRESHOLD_3:RW:16:10:=0x0100 PHY_NTP_EARLY_THRESHOLD_3:RW:0:10:=0x0100
#define              DENALI_PHY_811_DATA 0b00000000100000000000000110000000 // PHY_NTP_PERIOD_THRESHOLD_MAX_3:RW:16:10:=0x0080 PHY_NTP_PERIOD_THRESHOLD_MIN_3:RW:0:10:=0x0180
#define              DENALI_PHY_812_DATA 0b00000000000000000000000000000000 // PHY_FIFO_PTR_OBS_3:RD:16:8:=0x00 SC_PHY_MANUAL_CLEAR_3:WR:8:6:=0x00 PHY_CALVL_VREF_DRIVING_SLICE_3:RW:0:1:=0x00
#define              DENALI_PHY_813_DATA 0b00000000000000000000000000000000 // PHY_LPBK_RESULT_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_814_DATA 0b00000000000000000000000000000000 // PHY_MASTER_DLY_LOCK_OBS_3:RD:16:11:=0x0000 PHY_LPBK_ERROR_COUNT_OBS_3:RD:0:16:=0x0000
#define              DENALI_PHY_815_DATA 0b00000000000000000000000000000000 // PHY_RDDQS_DQ_FALL_ADDER_SLV_DLY_ENC_OBS_3:RD:24:8:=0x00 PHY_RDDQS_DQ_RISE_ADDER_SLV_DLY_ENC_OBS_3:RD:16:8:=0x00 PHY_RDDQS_BASE_SLV_DLY_ENC_OBS_3:RD:8:7:=0x00 PHY_RDDQ_SLV_DLY_ENC_OBS_3:RD:0:7:=0x00
#define              DENALI_PHY_816_DATA 0b00000000000000000000000000000000 // PHY_WRDQ_BASE_SLV_DLY_ENC_OBS_3:RD:24:8:=0x00 PHY_WRDQS_BASE_SLV_DLY_ENC_OBS_3:RD:16:7:=0x00 PHY_RDDQS_GATE_SLV_DLY_ENC_OBS_3:RD:0:11:=0x0000
#define              DENALI_PHY_817_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD0_DELAY_OBS_3:RD:16:10:=0x0000 PHY_WR_SHIFT_OBS_3:RD:8:3:=0x00 PHY_WR_ADDER_SLV_DLY_ENC_OBS_3:RD:0:8:=0x00
#define              DENALI_PHY_818_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_HARD1_DELAY_OBS_3:RD:0:10:=0x0000
#define              DENALI_PHY_819_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_STATUS_OBS_3:RD:0:17:=0x000000
#define              DENALI_PHY_820_DATA 0b00000000000000000000000000000000 // PHY_GATE_SMPL2_SLV_DLY_ENC_OBS_3:RD:16:10:=0x0000 PHY_GATE_SMPL1_SLV_DLY_ENC_OBS_3:RD:0:10:=0x0000
#define              DENALI_PHY_821_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD0_DELAY_OBS_3:RD:16:14:=0x0000 PHY_WRLVL_ERROR_OBS_3:RD:0:16:=0x0000
#define              DENALI_PHY_822_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_HARD1_DELAY_OBS_3:RD:0:14:=0x0000
#define              DENALI_PHY_823_DATA 0b00000000000000000000000000000000 // PHY_GTLVL_STATUS_OBS_3:RD:0:18:=0x000000
#define              DENALI_PHY_824_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_TE_DLY_OBS_3:RD:16:10:=0x0000 PHY_RDLVL_RDDQS_DQ_LE_DLY_OBS_3:RD:0:10:=0x0000
#define              DENALI_PHY_825_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_NUM_WINDOWS_OBS_3:RD:0:2:=0x00
#define              DENALI_PHY_826_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_STATUS_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_827_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_DQDM_TE_DLY_OBS_3:RD:16:11:=0x0000 PHY_WDQLVL_DQDM_LE_DLY_OBS_3:RD:0:11:=0x0000
#define              DENALI_PHY_828_DATA 0b00000000000000000000000000000000 // PHY_WDQLVL_STATUS_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_829_DATA 0b00000000000000000000000000000000 // PHY_DDL_MODE_3:RW:0:31:=0x00000000
#define              DENALI_PHY_830_DATA 0b00000000000000000000000000000000 // PHY_DDL_MASK_3:RW:0:6:=0x00
#define              DENALI_PHY_831_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_832_DATA 0b00000000000000000000000000000000 // PHY_DDL_TEST_MSTR_DLY_OBS_3:RD:0:32:=0x00000000
#define              DENALI_PHY_833_DATA 0b00000000000000000000000000000100 // PHY_RX_CAL_OVERRIDE_3:RW:24:1:=0x00 SC_PHY_RX_CAL_START_3:WR:16:1:=0x00 PHY_LP4_WDQS_OE_EXTEND_3:RW:8:1:=0x00 PHY_DDL_TRACK_UPD_THRESHOLD_3:RW:0:8:=0x04
#define              DENALI_PHY_834_DATA 0b00000000000000000000000000100000 // PHY_RX_CAL_DQ2_3:RW+:24:6:=0x00 PHY_RX_CAL_DQ1_3:RW+:16:6:=0x00 PHY_RX_CAL_DQ0_3:RW+:8:6:=0x00 PHY_RX_CAL_SAMPLE_WAIT_3:RW:0:8:=0x20
#define              DENALI_PHY_835_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_DQ6_3:RW+:24:6:=0x00 PHY_RX_CAL_DQ5_3:RW+:16:6:=0x00 PHY_RX_CAL_DQ4_3:RW+:8:6:=0x00 PHY_RX_CAL_DQ3_3:RW+:0:6:=0x00
#define              DENALI_PHY_836_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_FDBK_3:RW+:24:6:=0x00 PHY_RX_CAL_DQS_3:RW+:16:6:=0x00 PHY_RX_CAL_DM_3:RW+:8:6:=0x00 PHY_RX_CAL_DQ7_3:RW+:0:6:=0x00
#define              DENALI_PHY_837_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_LOCK_OBS_3:RD:16:9:=0x0000 PHY_RX_CAL_OBS_3:RD:0:11:=0x0000
#define              DENALI_PHY_838_DATA 0b00000000000000000000000000000000 // PHY_RX_CAL_COMP_VAL_3:RW:24:1:=0x00 PHY_RX_CAL_DIFF_ADJUST_3:RW:16:4:=0x00 PHY_RX_CAL_SE_ADJUST_3:RW:8:4:=0x00 PHY_RX_CAL_DISABLE_3:RW:0:1:=0x00
#define              DENALI_PHY_839_DATA 0b00000111111111110000000000000000 // PHY_PAD_RX_BIAS_EN_3:RW:16:11:=0x07ff PHY_RX_CAL_INDEX_MASK_3:RW:0:12:=0x0000
#define              DENALI_PHY_840_DATA 0b00100000000000001000000000001000 // PHY_DATA_DC_ADJUST_START_3:RW:24:6:=0x20 PHY_DATA_DC_WEIGHT_3:RW:16:2:=0x00 PHY_DATA_DC_CAL_TIMEOUT_3:RW:8:8:=0x80 PHY_DATA_DC_CAL_SAMPLE_WAIT_3:RW:0:8:=0x08
#define              DENALI_PHY_841_DATA 0b00000000000000000000100000010000 // PHY_DATA_DC_CAL_POLARITY_3:RW:24:1:=0x00 PHY_DATA_DC_ADJUST_DIRECT_3:RW:16:1:=0x00 PHY_DATA_DC_ADJUST_THRSHLD_3:RW:8:8:=0x08 PHY_DATA_DC_ADJUST_SAMPLE_CNT_3:RW:0:8:=0x10
#define              DENALI_PHY_842_DATA 0b00000000000001000000000100000000 // PHY_SLV_DLY_CTRL_GATE_DISABLE_3:RW_D:24:1:=0x00 PHY_FDBK_PWR_CTRL_3:RW:16:3:=0x04 PHY_DATA_DC_SW_RANK_3:RW+:8:2:=0x01 PHY_DATA_DC_CAL_START_3:RW+:0:1:=0x00
#define              DENALI_PHY_843_DATA 0b00000000000000000000000000000000 // PHY_SLICE_PWR_RDC_DISABLE_3:RW:16:1:=0x00 PHY_DCC_RXCAL_CTRL_GATE_DISABLE_3:RW_D:8:1:=0x00 PHY_RDPATH_GATE_DISABLE_3:RW_D:0:1:=0x00
#define              DENALI_PHY_844_DATA 0b00000001100010000000110000000001 // PHY_DQS_TSEL_ENABLE_3:RW+:24:3:=0x01 PHY_DQ_TSEL_SELECT_3:RW+:8:16:=0x880c PHY_DQ_TSEL_ENABLE_3:RW+:0:3:=0x01
#define              DENALI_PHY_845_DATA 0b00100000000000111000100000001100 // PHY_VREF_INITIAL_START_POINT_3:RW+:24:6:=0x20 PHY_TWO_CYC_PREAMBLE_3:RW+:16:2:=0x03 PHY_DQS_TSEL_SELECT_3:RW+:0:16:=0x880c
#define              DENALI_PHY_846_DATA 0b00100000000000000000000100100101 // PHY_NTP_WDQ_STEP_SIZE_3:RW+:24:8:=0x20 PHY_NTP_TRAIN_EN_3:RW+:16:1:=0x00 PHY_VREF_TRAINING_CTRL_3:RW+:8:2:=0x01 PHY_VREF_INITIAL_STOP_POINT_3:RW+:0:6:=0x25
#define              DENALI_PHY_847_DATA 0b00000111111111110000001000000000 // PHY_NTP_WDQ_STOP_3:RW+:16:11:=0x07FF PHY_NTP_WDQ_START_3:RW+:0:11:=0x0200
#define              DENALI_PHY_848_DATA 0b00000000000000000000000100000001 // PHY_PAD_RX_DCD_0_3:RW+:24:5:=0x00 PHY_PAD_TX_DCD_3:RW+:16:5:=0x00 PHY_FAST_LVL_EN_3:RW+:8:4:=0x01 PHY_NTP_WDQ_BIT_EN_3:RW+:0:8:=0x01
#define              DENALI_PHY_849_DATA 0b00000000000000000000000000000000 // PHY_PAD_RX_DCD_4_3:RW+:24:5:=0x00 PHY_PAD_RX_DCD_3_3:RW+:16:5:=0x00 PHY_PAD_RX_DCD_2_3:RW+:8:5:=0x00 PHY_PAD_RX_DCD_1_3:RW+:0:5:=0x00
#define              DENALI_PHY_850_DATA 0b00000000000000000000000000000000 // PHY_PAD_DM_RX_DCD_3:RW+:24:5:=0x00 PHY_PAD_RX_DCD_7_3:RW+:16:5:=0x00 PHY_PAD_RX_DCD_6_3:RW+:8:5:=0x00 PHY_PAD_RX_DCD_5_3:RW+:0:5:=0x00
#define              DENALI_PHY_851_DATA 0b00000000000000000000000000000000 // PHY_PAD_DSLICE_IO_CFG_3:RW+:16:6:=0x00 PHY_PAD_FDBK_RX_DCD_3:RW+:8:5:=0x00 PHY_PAD_DQS_RX_DCD_3:RW+:0:5:=0x00
#define              DENALI_PHY_852_DATA 0b00000000000000000000000000000000 // PHY_RDDQ1_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_RDDQ0_SLAVE_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_853_DATA 0b00000000000000000000000000000000 // PHY_RDDQ3_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_RDDQ2_SLAVE_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_854_DATA 0b00000000000000000000000000000000 // PHY_RDDQ5_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_RDDQ4_SLAVE_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_855_DATA 0b00000000000000000000000000000000 // PHY_RDDQ7_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_RDDQ6_SLAVE_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_856_DATA 0b00000000000000100000000000000000 // PHY_DATA_DC_CAL_CLK_SEL_3:RW+:16:3:=0x02 PHY_RDDM_SLAVE_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_857_DATA 0b01010001010100010101000001010010 // PHY_DQS_OE_TIMING_3:RW+:24:8:=0x51 PHY_DQ_TSEL_WR_TIMING_3:RW+:16:8:=0x51 PHY_DQ_TSEL_RD_TIMING_3:RW+:8:8:=0x50 PHY_DQ_OE_TIMING_3:RW+:0:8:=0x52
#define              DENALI_PHY_858_DATA 0b00110001110000000110000000000000 // PHY_DQS_TSEL_WR_TIMING_3:RW+:24:8:=0x31 PHY_DQS_OE_RD_TIMING_3:RW+:16:8:=0xc0 PHY_DQS_TSEL_RD_TIMING_3:RW+:8:8:=0x60 PHY_IO_PAD_DELAY_TIMING_3:RW+:0:4:=0x00
#define              DENALI_PHY_859_DATA 0b00000011110111110000000000000100 // PHY_PAD_VREF_CTRL_DQ_3:RW+:16:10:=0x011f PHY_VREF_SETTING_TIME_3:RW+:0:16:=0x0004
#define              DENALI_PHY_860_DATA 0b00000000110000001100000000000001 // PHY_RDDATA_EN_IE_DLY_3:RW+:24:2:=0x00 PHY_DQS_IE_TIMING_3:RW+:16:8:=0xc0 PHY_DQ_IE_TIMING_3:RW+:8:8:=0xc0 PHY_PER_CS_TRAINING_EN_3:RW+:0:1:=0x01
#define              DENALI_PHY_861_DATA 0b00000010000000000000000000000000 // PHY_WDQLVL_RDDATA_EN_DLY_3:RW+:24:5:=0x02 PHY_WDQLVL_IE_ON_3:RW+:16:1:=0x00 PHY_DBI_MODE_3:RW+:8:2:=0x00 PHY_IE_MODE_3:RW+:0:2:=0x00
#define              DENALI_PHY_862_DATA 0b00000000000000100000000100000001 // PHY_SW_MASTER_MODE_3:RW+:24:4:=0x00 PHY_RDDATA_EN_OE_DLY_3:RW+:16:5:=0x02 PHY_RDDATA_EN_TSEL_DLY_3:RW+:8:5:=0x01 PHY_WDQLVL_RDDATA_EN_TSEL_DLY_3:RW+:0:5:=0x01
#define              DENALI_PHY_863_DATA 0b01000010000100000000000000010000 // PHY_MASTER_DELAY_WAIT_3:RW+:24:8:=0x42 PHY_MASTER_DELAY_STEP_3:RW+:16:6:=0x10 PHY_MASTER_DELAY_START_3:RW+:0:11:=0x0010
#define              DENALI_PHY_864_DATA 0b00000001000011000000010000111110 // PHY_WRLVL_DLY_FINE_STEP_3:RW+:24:4:=0x01 PHY_WRLVL_DLY_STEP_3:RW+:16:8:=0x0c PHY_RPTR_UPDATE_3:RW+:8:4:=0x04 PHY_MASTER_DELAY_HALF_MEASURE_3:RW+:0:8:=0x3e
#define              DENALI_PHY_865_DATA 0b00000000000011110000110000011011 // PHY_GTLVL_RESP_WAIT_CNT_3:RW+:16:5:=0x0f PHY_GTLVL_DLY_STEP_3:RW+:8:4:=0x0c PHY_WRLVL_RESP_WAIT_CNT_3:RW+:0:6:=0x1b
#define              DENALI_PHY_866_DATA 0b00000001000000000000000101000000 // PHY_GTLVL_FINAL_STEP_3:RW+:16:10:=0x0100 PHY_GTLVL_BACK_STEP_3:RW+:0:10:=0x0140
#define              DENALI_PHY_867_DATA 0b00000000011110100000000100100000 // PHY_WDQLVL_DM_SEARCH_RANGE_3:RW+:16:9:=0x007a PHY_WDQLVL_QTR_DLY_STEP_3:RW+:8:4:=0x01 PHY_WDQLVL_DLY_STEP_3:RW+:0:8:=0x20
#define              DENALI_PHY_868_DATA 0b00000000000000000000110000000000 // PHY_RDLVL_DLY_STEP_3:RW+:8:4:=0x0c PHY_TOGGLE_PRE_SUPPORT_3:RW+:0:1:=0x00
#define              DENALI_PHY_869_DATA 0b00000000000000000000000111001100 // PHY_RDLVL_MAX_EDGE_3:RW+:0:10:=0x01cc
#define              DENALI_PHY_870_DATA 0b00000000000000000000001000000000 // PHY_DATA_DC_INIT_DISABLE_3:RW+:16:2:=0x00 PHY_WRPATH_GATE_TIMING_3:RW+:8:3:=0x02 PHY_WRPATH_GATE_DISABLE_3:RW+:0:2:=0x00
#define              DENALI_PHY_871_DATA 0b00000010100000000000000000000000 // PHY_DATA_DC_DQ_INIT_SLV_DELAY_3:RW+:16:11:=0x0280 PHY_DATA_DC_DQS_INIT_SLV_DELAY_3:RW+:0:10:=0x0000
#define              DENALI_PHY_872_DATA 0b10000000100000000000000100000001 // PHY_DATA_DC_DM_CLK_DIFF_THRSHLD_3:RW+:24:8:=0x80 PHY_DATA_DC_DM_CLK_SE_THRSHLD_3:RW+:16:8:=0x80 PHY_DATA_DC_WDQLVL_ENABLE_3:RW+:8:1:=0x01 PHY_DATA_DC_WRLVL_ENABLE_3:RW+:0:1:=0x01
#define              DENALI_PHY_873_DATA 0b00000000000000000000000000000010 // PHY_RDDATA_EN_DLY_3:RW+:0:5:=0x02
#define              DENALI_PHY_874_DATA 0b01110110010101000011001000010000 // PHY_DQ_DM_SWIZZLE0_3:RW+:0:32:=0x76543210
#define              DENALI_PHY_875_DATA 0b00000000000000000000000000001000 // PHY_DQ_DM_SWIZZLE1_3:RW+:0:4:=0x08
#define              DENALI_PHY_876_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ1_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ0_SLAVE_DELAY_3:RW+:0:11:=0x0280
#define              DENALI_PHY_877_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ3_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ2_SLAVE_DELAY_3:RW+:0:11:=0x0280
#define              DENALI_PHY_878_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ5_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ4_SLAVE_DELAY_3:RW+:0:11:=0x0280
#define              DENALI_PHY_879_DATA 0b00000010100000000000001010000000 // PHY_CLK_WRDQ7_SLAVE_DELAY_3:RW+:16:11:=0x0280 PHY_CLK_WRDQ6_SLAVE_DELAY_3:RW+:0:11:=0x0280
#define              DENALI_PHY_880_DATA 0b00000000000000000000001010000000 // PHY_CLK_WRDQS_SLAVE_DELAY_3:RW+:16:10:=0x0000 PHY_CLK_WRDM_SLAVE_DELAY_3:RW+:0:11:=0x0280
#define              DENALI_PHY_881_DATA 0b00000000000000001000000000000000 // PHY_RDDQS_DQ0_RISE_SLAVE_DELAY_3:RW+:8:10:=0x0080 PHY_WRLVL_THRESHOLD_ADJUST_3:RW+:0:2:=0x00
#define              DENALI_PHY_882_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ1_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ0_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_883_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ2_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ1_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_884_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ3_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ2_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_885_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ4_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ3_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_886_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ5_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ4_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_887_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ6_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ5_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_888_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DQ7_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ6_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_889_DATA 0b00000000100000000000000010000000 // PHY_RDDQS_DM_RISE_SLAVE_DELAY_3:RW+:16:10:=0x0080 PHY_RDDQS_DQ7_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_890_DATA 0b00000001000110010000000010000000 // PHY_RDDQS_GATE_SLAVE_DELAY_3:RW+:16:10:=0x0119 PHY_RDDQS_DM_FALL_SLAVE_DELAY_3:RW+:0:10:=0x0080
#define              DENALI_PHY_891_DATA 0b00000001101000000000000000000010 // PHY_WRLVL_DELAY_EARLY_THRESHOLD_3:RW+:16:10:=0x01A0 PHY_WRITE_PATH_LAT_ADD_3:RW+:8:3:=0x00 PHY_RDDQS_LATENCY_ADJUST_3:RW+:0:4:=0x02
#define              DENALI_PHY_892_DATA 0b00000000000000000000000000000000 // PHY_WRLVL_EARLY_FORCE_ZERO_3:RW+:16:1:=0x00 PHY_WRLVL_DELAY_PERIOD_THRESHOLD_3:RW+:0:10:=0x0000
#define              DENALI_PHY_893_DATA 0b00000000000000100000000000000000 // PHY_GTLVL_LAT_ADJ_START_3:RW+:16:4:=0x02 PHY_GTLVL_RDDQS_SLV_DLY_START_3:RW+:0:10:=0x0000
#define              DENALI_PHY_894_DATA 0b00000000000010000000001000000000 // PHY_NTP_PASS_3:RW+:24:1:=0x00 PHY_NTP_WRLAT_START_3:RW+:16:4:=0x08 PHY_WDQLVL_DQDM_SLV_DLY_START_3:RW+:0:11:=0x0200
#define              DENALI_PHY_895_DATA 0b00000000000000000000000000000000 // PHY_RDLVL_RDDQS_DQ_SLV_DLY_START_3:RW+:0:10:=0x0000
#define              DENALI_PHY_896_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ2_CLK_ADJUST_3:RW+:24:8:=0x20 PHY_DATA_DC_DQ1_CLK_ADJUST_3:RW+:16:8:=0x20 PHY_DATA_DC_DQ0_CLK_ADJUST_3:RW+:8:8:=0x20 PHY_DATA_DC_DQS_CLK_ADJUST_3:RW+:0:8:=0x20
#define              DENALI_PHY_897_DATA 0b00100000001000000010000000100000 // PHY_DATA_DC_DQ6_CLK_ADJUST_3:RW+:24:8:=0x20 PHY_DATA_DC_DQ5_CLK_ADJUST_3:RW+:16:8:=0x20 PHY_DATA_DC_DQ4_CLK_ADJUST_3:RW+:8:8:=0x20 PHY_DATA_DC_DQ3_CLK_ADJUST_3:RW+:0:8:=0x20
#define              DENALI_PHY_898_DATA 0b00000000000000000010000000100000 // PHY_DSLICE_PAD_BOOSTPN_SETTING_3:RW+:16:16:=0x0000 PHY_DATA_DC_DM_CLK_ADJUST_3:RW+:8:8:=0x20 PHY_DATA_DC_DQ7_CLK_ADJUST_3:RW+:0:8:=0x20
#define              DENALI_PHY_899_DATA 0b00000000000000000000000000000000 // PHY_DSLICE_PAD_RX_CTLE_SETTING_3:RW+:0:4:=0x00
#define              DENALI_PHY_900_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_901_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_902_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_903_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_904_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_905_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_906_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_907_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_908_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_909_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_910_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_911_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_912_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_913_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_914_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_915_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_916_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_917_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_918_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_919_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_920_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_921_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_922_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_923_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_924_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_925_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_926_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_927_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_928_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_929_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_930_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_931_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_932_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_933_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_934_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_935_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_936_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_937_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_938_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_939_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_940_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_941_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_942_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_943_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_944_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_945_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_946_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_947_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_948_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_949_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_950_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_951_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_952_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_953_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_954_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_955_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_956_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_957_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_958_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_959_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_960_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_961_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_962_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_963_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_964_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_965_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_966_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_967_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_968_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_969_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_970_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_971_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_972_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_973_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_974_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_975_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_976_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_977_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_978_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_979_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_980_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_981_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_982_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_983_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_984_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_985_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_986_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_987_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_988_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_989_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_990_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_991_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_992_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_993_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_994_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_995_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_996_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_997_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_998_DATA 0b00000000000000000000000000000000 //
#define              DENALI_PHY_999_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1000_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1001_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1002_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1003_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1004_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1005_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1006_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1007_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1008_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1009_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1010_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1011_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1012_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1013_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1014_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1015_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1016_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1017_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1018_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1019_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1020_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1021_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1022_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1023_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1024_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_MANUAL_CLEAR_0:WR:24:3:=0x00 PHY_ADR_CLK_BYPASS_OVERRIDE_0:RW:16:1:=0x00 PHY_ADR_CLK_WR_BYPASS_SLAVE_DELAY_0:RW:0:11:=0x0000
#define             DENALI_PHY_1025_DATA 0b00000000000000000000000000000000 // PHY_ADR_LPBK_RESULT_OBS_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1026_DATA 0b00000000000000000000000000000000 // PHY_ADR_MASTER_DLY_LOCK_OBS_SELECT_0:RW:16:4:=0x00 PHY_ADR_LPBK_ERROR_COUNT_OBS_0:RD:0:16:=0x0000
#define             DENALI_PHY_1027_DATA 0b00000000000000000000000000000000 // PHY_ADR_ADDER_SLV_DLY_ENC_OBS_0:RD:24:8:=0x00 PHY_ADR_BASE_SLV_DLY_ENC_OBS_0:RD:16:7:=0x00 PHY_ADR_MASTER_DLY_LOCK_OBS_0:RD:0:11:=0x0000
#define             DENALI_PHY_1028_DATA 0b00000000000000000000000000000000 // PHY_ADR_TSEL_ENABLE_0:RW:24:1:=0x00 SC_PHY_ADR_SNAP_OBS_REGS_0:WR:16:1:=0x00 PHY_ADR_SLV_DLY_ENC_OBS_SELECT_0:RW:8:3:=0x00 PHY_ADR_SLAVE_LOOP_CNT_UPDATE_0:RW:0:3:=0x00
#define             DENALI_PHY_1029_DATA 0b00000000000000000000000100000000 // PHY_ADR_PWR_RDC_DISABLE_0:RW:24:1:=0x00 PHY_ADR_PRBS_PATTERN_MASK_0:RW:16:5:=0x00 PHY_ADR_PRBS_PATTERN_START_0:RW_D:8:7:=0x01 PHY_ADR_LPBK_CONTROL_0:RW:0:7:=0x00
#define             DENALI_PHY_1030_DATA 0b00000000000000000000001000000000 // PHY_ADR_IE_MODE_0:RW:24:1:=0x00 PHY_ADR_WRADDR_SHIFT_OBS_0:RD:16:3:=0x00 PHY_ADR_TYPE_0:RW:8:2:=0x02 PHY_ADR_SLV_DLY_CTRL_GATE_DISABLE_0:RW_D:0:1:=0x00
#define             DENALI_PHY_1031_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MODE_0:RW:0:27:=0x00000000
#define             DENALI_PHY_1032_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MASK_0:RW:0:6:=0x00
#define             DENALI_PHY_1033_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_OBS_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1034_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_MSTR_DLY_OBS_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1035_DATA 0b00000000010000000000000000000000 // PHY_ADR_CALVL_COARSE_DLY_0:RW:16:11:=0x0040 PHY_ADR_CALVL_START_0:RW:0:11:=0x0000
#define             DENALI_PHY_1036_DATA 0b00000000000000000000000010000000 // PHY_ADR_CALVL_QTR_0:RW:0:11:=0x0080
#define             DENALI_PHY_1037_DATA 0b00000000110111001011101010011000 // PHY_ADR_CALVL_SWIZZLE0_0:RW:0:24:=0xdcba98
#define             DENALI_PHY_1038_DATA 0b00000011000000000000000000000000 // PHY_ADR_CALVL_RANK_CTRL_0:RW:24:2:=0x03 PHY_ADR_CALVL_SWIZZLE1_0:RW:0:24:=0x000000
#define             DENALI_PHY_1039_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_CALVL_DEBUG_CONT_0:WR:24:1:=0x00 PHY_ADR_CALVL_DEBUG_MODE_0:RW:16:1:=0x00 PHY_ADR_CALVL_RESP_WAIT_CNT_0:RW:8:4:=0x00 PHY_ADR_CALVL_NUM_PATTERNS_0:RW:0:2:=0x00
#define             DENALI_PHY_1040_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS_SELECT_0:RW:8:3:=0x00 SC_PHY_ADR_CALVL_ERROR_CLR_0:WR:0:1:=0x00
#define             DENALI_PHY_1041_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH0_OBS0_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1042_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH1_OBS0_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1043_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH2_OBS0_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1044_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH3_OBS0_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1045_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS1_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1046_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_FG_0_0:RW:0:20:=0x00002a
#define             DENALI_PHY_1047_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_BG_0_0:RW:0:20:=0x000015
#define             DENALI_PHY_1048_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_FG_1_0:RW:0:20:=0x000015
#define             DENALI_PHY_1049_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_BG_1_0:RW:0:20:=0x00002a
#define             DENALI_PHY_1050_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_FG_2_0:RW:0:20:=0x000033
#define             DENALI_PHY_1051_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_BG_2_0:RW:0:20:=0x00000c
#define             DENALI_PHY_1052_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_FG_3_0:RW:0:20:=0x00000c
#define             DENALI_PHY_1053_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_BG_3_0:RW:0:20:=0x000033
#define             DENALI_PHY_1054_DATA 0b00001010010000011000100000100000 // PHY_ADR_ADDR_SEL_0:RW:0:30:=0x0a418820
#define             DENALI_PHY_1055_DATA 0b00000000001111110000000000000000 // PHY_ADR_SEG_MASK_0:RW:24:6:=0x00 PHY_ADR_BIT_MASK_0:RW:16:6:=0x3f PHY_ADR_LP4_BOOT_SLV_DELAY_0:RW:0:10:=0x0000
#define             DENALI_PHY_1056_DATA 0b00000000000000000000000100111111 // PHY_ADR_SW_TXIO_CTRL_0:RW:16:6:=0x00 PHY_ADR_CSLVL_TRAIN_MASK_0:RW:8:6:=0x01 PHY_ADR_CALVL_TRAIN_MASK_0:RW:0:6:=0x3f
#define             DENALI_PHY_1057_DATA 0b00100000001000000010000000000000 // PHY_ADR_DC_ADR2_CLK_ADJUST_0:RW+:24:8:=0x20 PHY_ADR_DC_ADR1_CLK_ADJUST_0:RW+:16:8:=0x20 PHY_ADR_DC_ADR0_CLK_ADJUST_0:RW+:8:8:=0x20 PHY_ADR_DC_INIT_DISABLE_0:RW+:0:2:=0x00
#define             DENALI_PHY_1058_DATA 0b00000000001000000010000000100000 // PHY_ADR_DCC_RXCAL_CTRL_GATE_DISABLE_0:RW_D:24:1:=0x00 PHY_ADR_DC_ADR5_CLK_ADJUST_0:RW+:16:8:=0x20 PHY_ADR_DC_ADR4_CLK_ADJUST_0:RW+:8:8:=0x20 PHY_ADR_DC_ADR3_CLK_ADJUST_0:RW+:0:8:=0x20
#define             DENALI_PHY_1059_DATA 0b00100000000000001000000000001000 // PHY_ADR_DC_ADJUST_START_0:RW:24:6:=0x20 PHY_ADR_DC_WEIGHT_0:RW:16:2:=0x00 PHY_ADR_DC_CAL_TIMEOUT_0:RW:8:8:=0x80 PHY_ADR_DC_CAL_SAMPLE_WAIT_0:RW:0:8:=0x08
#define             DENALI_PHY_1060_DATA 0b00000000000000000000100000010000 // PHY_ADR_DC_CAL_POLARITY_0:RW:24:1:=0x00 PHY_ADR_DC_ADJUST_DIRECT_0:RW:16:1:=0x00 PHY_ADR_DC_ADJUST_THRSHLD_0:RW:8:8:=0x08 PHY_ADR_DC_ADJUST_SAMPLE_CNT_0:RW:0:8:=0x10
#define             DENALI_PHY_1061_DATA 0b00000000000000000000000000000000 // PHY_ADR_DC_CAL_START_0:RW+:0:1:=0x00
#define             DENALI_PHY_1062_DATA 0b00000000000000000000001001010101 // PHY_PAD_ADR_IO_CFG_0:RW+:16:11:=0x0000 PHY_ADR_DC_CAL_CLK_SEL_0:RW+:8:3:=0x02 PHY_ADR_TSEL_SELECT_0:RW+:0:8:=0x55
#define             DENALI_PHY_1063_DATA 0b00000000000000110000000000000000 // PHY_ADR1_SW_WRADDR_SHIFT_0:RW+:24:5:=0x00 PHY_ADR0_CLK_WR_SLAVE_DELAY_0:RW+:8:11:=0x0300 PHY_ADR0_SW_WRADDR_SHIFT_0:RW+:0:5:=0x00
#define             DENALI_PHY_1064_DATA 0b00000000000000000000001100000000 // PHY_ADR2_SW_WRADDR_SHIFT_0:RW+:16:5:=0x00 PHY_ADR1_CLK_WR_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1065_DATA 0b00000000000000000000001100000000 // PHY_ADR3_SW_WRADDR_SHIFT_0:RW+:16:5:=0x00 PHY_ADR2_CLK_WR_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1066_DATA 0b00000000000000000000001100000000 // PHY_ADR4_SW_WRADDR_SHIFT_0:RW+:16:5:=0x00 PHY_ADR3_CLK_WR_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1067_DATA 0b00000000000000000000001100000000 // PHY_ADR5_SW_WRADDR_SHIFT_0:RW+:16:5:=0x00 PHY_ADR4_CLK_WR_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1068_DATA 0b00000000000000000000001100000000 // PHY_ADR_SW_MASTER_MODE_0:RW+:16:4:=0x00 PHY_ADR5_CLK_WR_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1069_DATA 0b01000010000010000000000000010000 // PHY_ADR_MASTER_DELAY_WAIT_0:RW+:24:8:=0x42 PHY_ADR_MASTER_DELAY_STEP_0:RW+:16:6:=0x08 PHY_ADR_MASTER_DELAY_START_0:RW+:0:11:=0x0010
#define             DENALI_PHY_1070_DATA 0b00000000000000000000001100111110 // PHY_ADR_CALVL_DLY_STEP_0:RW+:8:4:=0x03 PHY_ADR_MASTER_DELAY_HALF_MEASURE_0:RW+:0:8:=0x3e
#define             DENALI_PHY_1071_DATA 0b00000001000000010000000000000010 // PHY_ADR_DC_CALVL_ENABLE_0:RW+:24:1:=0x01 PHY_ADR_DC_INIT_SLV_DELAY_0:RW+:8:10:=0x0100 PHY_ADR_CALVL_CAPTURE_CNT_0:RW+:0:4:=0x02
#define             DENALI_PHY_1072_DATA 0b00000000000000000000000010000000 // PHY_ADR_DC_DM_CLK_THRSHLD_0:RW+:0:8:=0x80
#define             DENALI_PHY_1073_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1074_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1075_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1076_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1077_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1078_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1079_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1080_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1081_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1082_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1083_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1084_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1085_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1086_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1087_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1088_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1089_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1090_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1091_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1092_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1093_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1094_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1095_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1096_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1097_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1098_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1099_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1100_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1101_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1102_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1103_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1104_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1105_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1106_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1107_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1108_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1109_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1110_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1111_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1112_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1113_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1114_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1115_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1116_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1117_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1118_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1119_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1120_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1121_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1122_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1123_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1124_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1125_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1126_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1127_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1128_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1129_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1130_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1131_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1132_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1133_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1134_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1135_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1136_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1137_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1138_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1139_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1140_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1141_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1142_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1143_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1144_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1145_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1146_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1147_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1148_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1149_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1150_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1151_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1152_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1153_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1154_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1155_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1156_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1157_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1158_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1159_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1160_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1161_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1162_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1163_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1164_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1165_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1166_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1167_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1168_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1169_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1170_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1171_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1172_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1173_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1174_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1175_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1176_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1177_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1178_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1179_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1180_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1181_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1182_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1183_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1184_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1185_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1186_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1187_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1188_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1189_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1190_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1191_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1192_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1193_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1194_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1195_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1196_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1197_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1198_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1199_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1200_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1201_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1202_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1203_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1204_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1205_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1206_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1207_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1208_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1209_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1210_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1211_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1212_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1213_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1214_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1215_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1216_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1217_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1218_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1219_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1220_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1221_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1222_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1223_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1224_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1225_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1226_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1227_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1228_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1229_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1230_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1231_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1232_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1233_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1234_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1235_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1236_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1237_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1238_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1239_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1240_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1241_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1242_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1243_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1244_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1245_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1246_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1247_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1248_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1249_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1250_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1251_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1252_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1253_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1254_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1255_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1256_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1257_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1258_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1259_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1260_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1261_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1262_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1263_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1264_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1265_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1266_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1267_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1268_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1269_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1270_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1271_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1272_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1273_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1274_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1275_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1276_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1277_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1278_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1279_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1280_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_MANUAL_CLEAR_1:WR:24:3:=0x00 PHY_ADR_CLK_BYPASS_OVERRIDE_1:RW:16:1:=0x00 PHY_ADR_CLK_WR_BYPASS_SLAVE_DELAY_1:RW:0:11:=0x0000
#define             DENALI_PHY_1281_DATA 0b00000000000000000000000000000000 // PHY_ADR_LPBK_RESULT_OBS_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1282_DATA 0b00000000000000000000000000000000 // PHY_ADR_MASTER_DLY_LOCK_OBS_SELECT_1:RW:16:4:=0x00 PHY_ADR_LPBK_ERROR_COUNT_OBS_1:RD:0:16:=0x0000
#define             DENALI_PHY_1283_DATA 0b00000000000000000000000000000000 // PHY_ADR_ADDER_SLV_DLY_ENC_OBS_1:RD:24:8:=0x00 PHY_ADR_BASE_SLV_DLY_ENC_OBS_1:RD:16:7:=0x00 PHY_ADR_MASTER_DLY_LOCK_OBS_1:RD:0:11:=0x0000
#define             DENALI_PHY_1284_DATA 0b00000000000000000000000000000000 // PHY_ADR_TSEL_ENABLE_1:RW:24:1:=0x00 SC_PHY_ADR_SNAP_OBS_REGS_1:WR:16:1:=0x00 PHY_ADR_SLV_DLY_ENC_OBS_SELECT_1:RW:8:3:=0x00 PHY_ADR_SLAVE_LOOP_CNT_UPDATE_1:RW:0:3:=0x00
#define             DENALI_PHY_1285_DATA 0b00000000000000000000000100000000 // PHY_ADR_PWR_RDC_DISABLE_1:RW:24:1:=0x00 PHY_ADR_PRBS_PATTERN_MASK_1:RW:16:5:=0x00 PHY_ADR_PRBS_PATTERN_START_1:RW_D:8:7:=0x01 PHY_ADR_LPBK_CONTROL_1:RW:0:7:=0x00
#define             DENALI_PHY_1286_DATA 0b00000000000000000000001000000000 // PHY_ADR_IE_MODE_1:RW:24:1:=0x00 PHY_ADR_WRADDR_SHIFT_OBS_1:RD:16:3:=0x00 PHY_ADR_TYPE_1:RW:8:2:=0x02 PHY_ADR_SLV_DLY_CTRL_GATE_DISABLE_1:RW_D:0:1:=0x00
#define             DENALI_PHY_1287_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MODE_1:RW:0:27:=0x00000000
#define             DENALI_PHY_1288_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MASK_1:RW:0:6:=0x00
#define             DENALI_PHY_1289_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_OBS_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1290_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_MSTR_DLY_OBS_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1291_DATA 0b00000000010000000000000000000000 // PHY_ADR_CALVL_COARSE_DLY_1:RW:16:11:=0x0040 PHY_ADR_CALVL_START_1:RW:0:11:=0x0000
#define             DENALI_PHY_1292_DATA 0b00000000000000000000000010000000 // PHY_ADR_CALVL_QTR_1:RW:0:11:=0x0080
#define             DENALI_PHY_1293_DATA 0b00000000110111001011101010011000 // PHY_ADR_CALVL_SWIZZLE0_1:RW:0:24:=0xdcba98
#define             DENALI_PHY_1294_DATA 0b00000011000000000000000000000000 // PHY_ADR_CALVL_RANK_CTRL_1:RW:24:2:=0x03 PHY_ADR_CALVL_SWIZZLE1_1:RW:0:24:=0x000000
#define             DENALI_PHY_1295_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_CALVL_DEBUG_CONT_1:WR:24:1:=0x00 PHY_ADR_CALVL_DEBUG_MODE_1:RW:16:1:=0x00 PHY_ADR_CALVL_RESP_WAIT_CNT_1:RW:8:4:=0x00 PHY_ADR_CALVL_NUM_PATTERNS_1:RW:0:2:=0x00
#define             DENALI_PHY_1296_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS_SELECT_1:RW:8:3:=0x00 SC_PHY_ADR_CALVL_ERROR_CLR_1:WR:0:1:=0x00
#define             DENALI_PHY_1297_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH0_OBS0_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1298_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH1_OBS0_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1299_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH2_OBS0_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1300_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH3_OBS0_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1301_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS1_1:RD:0:32:=0x00000000
#define             DENALI_PHY_1302_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_FG_0_1:RW:0:20:=0x00002a
#define             DENALI_PHY_1303_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_BG_0_1:RW:0:20:=0x000015
#define             DENALI_PHY_1304_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_FG_1_1:RW:0:20:=0x000015
#define             DENALI_PHY_1305_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_BG_1_1:RW:0:20:=0x00002a
#define             DENALI_PHY_1306_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_FG_2_1:RW:0:20:=0x000033
#define             DENALI_PHY_1307_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_BG_2_1:RW:0:20:=0x00000c
#define             DENALI_PHY_1308_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_FG_3_1:RW:0:20:=0x00000c
#define             DENALI_PHY_1309_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_BG_3_1:RW:0:20:=0x000033
#define             DENALI_PHY_1310_DATA 0b00000000000000000000000000000000 // PHY_ADR_ADDR_SEL_1:RW:0:30:=0x00000000
#define             DENALI_PHY_1311_DATA 0b00000000000000000000000000000000 // PHY_ADR_SEG_MASK_1:RW:24:6:=0x00 PHY_ADR_BIT_MASK_1:RW:16:6:=0x00 PHY_ADR_LP4_BOOT_SLV_DELAY_1:RW:0:10:=0x0000
#define             DENALI_PHY_1312_DATA 0b00000000000000000000000000000000 // PHY_ADR_SW_TXIO_CTRL_1:RW:16:6:=0x00 PHY_ADR_CSLVL_TRAIN_MASK_1:RW:8:6:=0x00 PHY_ADR_CALVL_TRAIN_MASK_1:RW:0:6:=0x00
#define             DENALI_PHY_1313_DATA 0b00100000001000000010000000000000 // PHY_ADR_DC_ADR2_CLK_ADJUST_1:RW+:24:8:=0x20 PHY_ADR_DC_ADR1_CLK_ADJUST_1:RW+:16:8:=0x20 PHY_ADR_DC_ADR0_CLK_ADJUST_1:RW+:8:8:=0x20 PHY_ADR_DC_INIT_DISABLE_1:RW+:0:2:=0x00
#define             DENALI_PHY_1314_DATA 0b00000000001000000010000000100000 // PHY_ADR_DCC_RXCAL_CTRL_GATE_DISABLE_1:RW_D:24:1:=0x00 PHY_ADR_DC_ADR5_CLK_ADJUST_1:RW+:16:8:=0x20 PHY_ADR_DC_ADR4_CLK_ADJUST_1:RW+:8:8:=0x20 PHY_ADR_DC_ADR3_CLK_ADJUST_1:RW+:0:8:=0x20
#define             DENALI_PHY_1315_DATA 0b00100000000000001000000000001000 // PHY_ADR_DC_ADJUST_START_1:RW:24:6:=0x20 PHY_ADR_DC_WEIGHT_1:RW:16:2:=0x00 PHY_ADR_DC_CAL_TIMEOUT_1:RW:8:8:=0x80 PHY_ADR_DC_CAL_SAMPLE_WAIT_1:RW:0:8:=0x08
#define             DENALI_PHY_1316_DATA 0b00000000000000000000100000010000 // PHY_ADR_DC_CAL_POLARITY_1:RW:24:1:=0x00 PHY_ADR_DC_ADJUST_DIRECT_1:RW:16:1:=0x00 PHY_ADR_DC_ADJUST_THRSHLD_1:RW:8:8:=0x08 PHY_ADR_DC_ADJUST_SAMPLE_CNT_1:RW:0:8:=0x10
#define             DENALI_PHY_1317_DATA 0b00000000000000000000000000000000 // PHY_ADR_DC_CAL_START_1:RW+:0:1:=0x00
#define             DENALI_PHY_1318_DATA 0b00000000000000000000001001010101 // PHY_PAD_ADR_IO_CFG_1:RW+:16:11:=0x0000 PHY_ADR_DC_CAL_CLK_SEL_1:RW+:8:3:=0x02 PHY_ADR_TSEL_SELECT_1:RW+:0:8:=0x55
#define             DENALI_PHY_1319_DATA 0b00000000000000110000000000000000 // PHY_ADR1_SW_WRADDR_SHIFT_1:RW+:24:5:=0x00 PHY_ADR0_CLK_WR_SLAVE_DELAY_1:RW+:8:11:=0x0300 PHY_ADR0_SW_WRADDR_SHIFT_1:RW+:0:5:=0x00
#define             DENALI_PHY_1320_DATA 0b00000000000000000000001100000000 // PHY_ADR2_SW_WRADDR_SHIFT_1:RW+:16:5:=0x00 PHY_ADR1_CLK_WR_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1321_DATA 0b00000000000000000000001100000000 // PHY_ADR3_SW_WRADDR_SHIFT_1:RW+:16:5:=0x00 PHY_ADR2_CLK_WR_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1322_DATA 0b00000000000000000000001100000000 // PHY_ADR4_SW_WRADDR_SHIFT_1:RW+:16:5:=0x00 PHY_ADR3_CLK_WR_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1323_DATA 0b00000000000000000000001100000000 // PHY_ADR5_SW_WRADDR_SHIFT_1:RW+:16:5:=0x00 PHY_ADR4_CLK_WR_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1324_DATA 0b00000000000000000000001100000000 // PHY_ADR_SW_MASTER_MODE_1:RW+:16:4:=0x00 PHY_ADR5_CLK_WR_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1325_DATA 0b01000010000010000000000000010000 // PHY_ADR_MASTER_DELAY_WAIT_1:RW+:24:8:=0x42 PHY_ADR_MASTER_DELAY_STEP_1:RW+:16:6:=0x08 PHY_ADR_MASTER_DELAY_START_1:RW+:0:11:=0x0010
#define             DENALI_PHY_1326_DATA 0b00000000000000000000001100111110 // PHY_ADR_CALVL_DLY_STEP_1:RW+:8:4:=0x03 PHY_ADR_MASTER_DELAY_HALF_MEASURE_1:RW+:0:8:=0x3e
#define             DENALI_PHY_1327_DATA 0b00000001000000010000000000000010 // PHY_ADR_DC_CALVL_ENABLE_1:RW+:24:1:=0x01 PHY_ADR_DC_INIT_SLV_DELAY_1:RW+:8:10:=0x0100 PHY_ADR_CALVL_CAPTURE_CNT_1:RW+:0:4:=0x02
#define             DENALI_PHY_1328_DATA 0b00000000000000000000000010000000 // PHY_ADR_DC_DM_CLK_THRSHLD_1:RW+:0:8:=0x80
#define             DENALI_PHY_1329_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1330_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1331_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1332_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1333_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1334_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1335_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1336_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1337_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1338_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1339_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1340_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1341_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1342_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1343_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1344_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1345_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1346_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1347_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1348_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1349_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1350_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1351_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1352_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1353_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1354_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1355_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1356_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1357_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1358_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1359_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1360_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1361_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1362_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1363_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1364_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1365_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1366_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1367_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1368_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1369_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1370_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1371_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1372_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1373_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1374_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1375_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1376_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1377_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1378_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1379_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1380_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1381_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1382_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1383_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1384_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1385_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1386_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1387_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1388_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1389_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1390_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1391_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1392_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1393_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1394_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1395_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1396_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1397_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1398_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1399_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1400_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1401_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1402_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1403_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1404_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1405_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1406_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1407_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1408_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1409_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1410_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1411_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1412_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1413_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1414_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1415_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1416_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1417_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1418_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1419_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1420_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1421_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1422_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1423_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1424_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1425_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1426_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1427_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1428_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1429_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1430_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1431_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1432_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1433_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1434_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1435_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1436_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1437_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1438_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1439_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1440_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1441_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1442_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1443_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1444_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1445_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1446_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1447_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1448_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1449_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1450_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1451_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1452_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1453_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1454_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1455_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1456_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1457_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1458_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1459_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1460_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1461_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1462_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1463_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1464_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1465_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1466_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1467_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1468_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1469_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1470_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1471_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1472_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1473_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1474_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1475_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1476_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1477_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1478_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1479_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1480_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1481_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1482_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1483_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1484_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1485_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1486_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1487_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1488_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1489_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1490_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1491_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1492_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1493_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1494_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1495_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1496_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1497_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1498_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1499_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1500_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1501_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1502_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1503_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1504_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1505_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1506_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1507_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1508_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1509_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1510_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1511_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1512_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1513_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1514_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1515_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1516_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1517_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1518_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1519_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1520_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1521_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1522_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1523_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1524_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1525_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1526_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1527_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1528_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1529_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1530_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1531_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1532_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1533_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1534_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1535_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1536_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_MANUAL_CLEAR_2:WR:24:3:=0x00 PHY_ADR_CLK_BYPASS_OVERRIDE_2:RW:16:1:=0x00 PHY_ADR_CLK_WR_BYPASS_SLAVE_DELAY_2:RW:0:11:=0x0000
#define             DENALI_PHY_1537_DATA 0b00000000000000000000000000000000 // PHY_ADR_LPBK_RESULT_OBS_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1538_DATA 0b00000000000000000000000000000000 // PHY_ADR_MASTER_DLY_LOCK_OBS_SELECT_2:RW:16:4:=0x00 PHY_ADR_LPBK_ERROR_COUNT_OBS_2:RD:0:16:=0x0000
#define             DENALI_PHY_1539_DATA 0b00000000000000000000000000000000 // PHY_ADR_ADDER_SLV_DLY_ENC_OBS_2:RD:24:8:=0x00 PHY_ADR_BASE_SLV_DLY_ENC_OBS_2:RD:16:7:=0x00 PHY_ADR_MASTER_DLY_LOCK_OBS_2:RD:0:11:=0x0000
#define             DENALI_PHY_1540_DATA 0b00000000000000000000000000000000 // PHY_ADR_TSEL_ENABLE_2:RW:24:1:=0x00 SC_PHY_ADR_SNAP_OBS_REGS_2:WR:16:1:=0x00 PHY_ADR_SLV_DLY_ENC_OBS_SELECT_2:RW:8:3:=0x00 PHY_ADR_SLAVE_LOOP_CNT_UPDATE_2:RW:0:3:=0x00
#define             DENALI_PHY_1541_DATA 0b00000000000000000000000100000000 // PHY_ADR_PWR_RDC_DISABLE_2:RW:24:1:=0x00 PHY_ADR_PRBS_PATTERN_MASK_2:RW:16:5:=0x00 PHY_ADR_PRBS_PATTERN_START_2:RW_D:8:7:=0x01 PHY_ADR_LPBK_CONTROL_2:RW:0:7:=0x00
#define             DENALI_PHY_1542_DATA 0b00000000000000000000001000000000 // PHY_ADR_IE_MODE_2:RW:24:1:=0x00 PHY_ADR_WRADDR_SHIFT_OBS_2:RD:16:3:=0x00 PHY_ADR_TYPE_2:RW:8:2:=0x02 PHY_ADR_SLV_DLY_CTRL_GATE_DISABLE_2:RW_D:0:1:=0x00
#define             DENALI_PHY_1543_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MODE_2:RW:0:27:=0x00000000
#define             DENALI_PHY_1544_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_MASK_2:RW:0:6:=0x00
#define             DENALI_PHY_1545_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_OBS_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1546_DATA 0b00000000000000000000000000000000 // PHY_ADR_DDL_TEST_MSTR_DLY_OBS_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1547_DATA 0b00000000010000000000000000000000 // PHY_ADR_CALVL_COARSE_DLY_2:RW:16:11:=0x0040 PHY_ADR_CALVL_START_2:RW:0:11:=0x0000
#define             DENALI_PHY_1548_DATA 0b00000000000000000000000010000000 // PHY_ADR_CALVL_QTR_2:RW:0:11:=0x0080
#define             DENALI_PHY_1549_DATA 0b00000000110111001011101010011000 // PHY_ADR_CALVL_SWIZZLE0_2:RW:0:24:=0xdcba98
#define             DENALI_PHY_1550_DATA 0b00000011000000000000000000000000 // PHY_ADR_CALVL_RANK_CTRL_2:RW:24:2:=0x03 PHY_ADR_CALVL_SWIZZLE1_2:RW:0:24:=0x000000
#define             DENALI_PHY_1551_DATA 0b00000000000000000000000000000000 // SC_PHY_ADR_CALVL_DEBUG_CONT_2:WR:24:1:=0x00 PHY_ADR_CALVL_DEBUG_MODE_2:RW:16:1:=0x00 PHY_ADR_CALVL_RESP_WAIT_CNT_2:RW:8:4:=0x00 PHY_ADR_CALVL_NUM_PATTERNS_2:RW:0:2:=0x00
#define             DENALI_PHY_1552_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS_SELECT_2:RW:8:3:=0x00 SC_PHY_ADR_CALVL_ERROR_CLR_2:WR:0:1:=0x00
#define             DENALI_PHY_1553_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH0_OBS0_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1554_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH1_OBS0_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1555_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH2_OBS0_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1556_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_CH3_OBS0_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1557_DATA 0b00000000000000000000000000000000 // PHY_ADR_CALVL_OBS1_2:RD:0:32:=0x00000000
#define             DENALI_PHY_1558_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_FG_0_2:RW:0:20:=0x00002a
#define             DENALI_PHY_1559_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_BG_0_2:RW:0:20:=0x000015
#define             DENALI_PHY_1560_DATA 0b00000000000000000000000000010101 // PHY_ADR_CALVL_FG_1_2:RW:0:20:=0x000015
#define             DENALI_PHY_1561_DATA 0b00000000000000000000000000101010 // PHY_ADR_CALVL_BG_1_2:RW:0:20:=0x00002a
#define             DENALI_PHY_1562_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_FG_2_2:RW:0:20:=0x000033
#define             DENALI_PHY_1563_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_BG_2_2:RW:0:20:=0x00000c
#define             DENALI_PHY_1564_DATA 0b00000000000000000000000000001100 // PHY_ADR_CALVL_FG_3_2:RW:0:20:=0x00000c
#define             DENALI_PHY_1565_DATA 0b00000000000000000000000000110011 // PHY_ADR_CALVL_BG_3_2:RW:0:20:=0x000033
#define             DENALI_PHY_1566_DATA 0b00000000000000000000000000000000 // PHY_ADR_ADDR_SEL_2:RW:0:30:=0x00000000
#define             DENALI_PHY_1567_DATA 0b00010000000000000000000000000000 // PHY_ADR_SEG_MASK_2:RW:24:6:=0x10 PHY_ADR_BIT_MASK_2:RW:16:6:=0x00 PHY_ADR_LP4_BOOT_SLV_DELAY_2:RW:0:10:=0x0000
#define             DENALI_PHY_1568_DATA 0b00000000000000000000000000000000 // PHY_ADR_SW_TXIO_CTRL_2:RW:16:6:=0x00 PHY_ADR_CSLVL_TRAIN_MASK_2:RW:8:6:=0x00 PHY_ADR_CALVL_TRAIN_MASK_2:RW:0:6:=0x00
#define             DENALI_PHY_1569_DATA 0b00100000001000000010000000000000 // PHY_ADR_DC_ADR2_CLK_ADJUST_2:RW+:24:8:=0x20 PHY_ADR_DC_ADR1_CLK_ADJUST_2:RW+:16:8:=0x20 PHY_ADR_DC_ADR0_CLK_ADJUST_2:RW+:8:8:=0x20 PHY_ADR_DC_INIT_DISABLE_2:RW+:0:2:=0x00
#define             DENALI_PHY_1570_DATA 0b00000000001000000010000000100000 // PHY_ADR_DCC_RXCAL_CTRL_GATE_DISABLE_2:RW_D:24:1:=0x00 PHY_ADR_DC_ADR5_CLK_ADJUST_2:RW+:16:8:=0x20 PHY_ADR_DC_ADR4_CLK_ADJUST_2:RW+:8:8:=0x20 PHY_ADR_DC_ADR3_CLK_ADJUST_2:RW+:0:8:=0x20
#define             DENALI_PHY_1571_DATA 0b00100000000000001000000000001000 // PHY_ADR_DC_ADJUST_START_2:RW:24:6:=0x20 PHY_ADR_DC_WEIGHT_2:RW:16:2:=0x00 PHY_ADR_DC_CAL_TIMEOUT_2:RW:8:8:=0x80 PHY_ADR_DC_CAL_SAMPLE_WAIT_2:RW:0:8:=0x08
#define             DENALI_PHY_1572_DATA 0b00000000000000000000100000010000 // PHY_ADR_DC_CAL_POLARITY_2:RW:24:1:=0x00 PHY_ADR_DC_ADJUST_DIRECT_2:RW:16:1:=0x00 PHY_ADR_DC_ADJUST_THRSHLD_2:RW:8:8:=0x08 PHY_ADR_DC_ADJUST_SAMPLE_CNT_2:RW:0:8:=0x10
#define             DENALI_PHY_1573_DATA 0b00000000000000000000000000000000 // PHY_ADR_DC_CAL_START_2:RW+:0:1:=0x00
#define             DENALI_PHY_1574_DATA 0b00000000000000000000001001010101 // PHY_PAD_ADR_IO_CFG_2:RW+:16:11:=0x0000 PHY_ADR_DC_CAL_CLK_SEL_2:RW+:8:3:=0x02 PHY_ADR_TSEL_SELECT_2:RW+:0:8:=0x55
#define             DENALI_PHY_1575_DATA 0b00000000000000110000000000000000 // PHY_ADR1_SW_WRADDR_SHIFT_2:RW+:24:5:=0x00 PHY_ADR0_CLK_WR_SLAVE_DELAY_2:RW+:8:11:=0x0300 PHY_ADR0_SW_WRADDR_SHIFT_2:RW+:0:5:=0x00
#define             DENALI_PHY_1576_DATA 0b00000000000000000000001100000000 // PHY_ADR2_SW_WRADDR_SHIFT_2:RW+:16:5:=0x00 PHY_ADR1_CLK_WR_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1577_DATA 0b00000000000000000000001100000000 // PHY_ADR3_SW_WRADDR_SHIFT_2:RW+:16:5:=0x00 PHY_ADR2_CLK_WR_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1578_DATA 0b00000000000000000000001100000000 // PHY_ADR4_SW_WRADDR_SHIFT_2:RW+:16:5:=0x00 PHY_ADR3_CLK_WR_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1579_DATA 0b00000000000000000000001100000000 // PHY_ADR5_SW_WRADDR_SHIFT_2:RW+:16:5:=0x00 PHY_ADR4_CLK_WR_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1580_DATA 0b00000000000000000000001100000000 // PHY_ADR_SW_MASTER_MODE_2:RW+:16:4:=0x00 PHY_ADR5_CLK_WR_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1581_DATA 0b01000010000010000000000000010000 // PHY_ADR_MASTER_DELAY_WAIT_2:RW+:24:8:=0x42 PHY_ADR_MASTER_DELAY_STEP_2:RW+:16:6:=0x08 PHY_ADR_MASTER_DELAY_START_2:RW+:0:11:=0x0010
#define             DENALI_PHY_1582_DATA 0b00000000000000000000001100111110 // PHY_ADR_CALVL_DLY_STEP_2:RW+:8:4:=0x03 PHY_ADR_MASTER_DELAY_HALF_MEASURE_2:RW+:0:8:=0x3e
#define             DENALI_PHY_1583_DATA 0b00000001000000010000000000000010 // PHY_ADR_DC_CALVL_ENABLE_2:RW+:24:1:=0x01 PHY_ADR_DC_INIT_SLV_DELAY_2:RW+:8:10:=0x0100 PHY_ADR_CALVL_CAPTURE_CNT_2:RW+:0:4:=0x02
#define             DENALI_PHY_1584_DATA 0b00000000000000000000000010000000 // PHY_ADR_DC_DM_CLK_THRSHLD_2:RW+:0:8:=0x80
#define             DENALI_PHY_1585_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1586_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1587_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1588_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1589_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1590_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1591_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1592_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1593_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1594_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1595_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1596_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1597_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1598_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1599_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1600_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1601_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1602_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1603_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1604_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1605_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1606_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1607_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1608_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1609_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1610_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1611_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1612_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1613_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1614_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1615_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1616_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1617_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1618_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1619_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1620_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1621_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1622_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1623_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1624_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1625_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1626_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1627_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1628_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1629_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1630_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1631_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1632_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1633_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1634_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1635_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1636_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1637_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1638_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1639_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1640_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1641_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1642_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1643_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1644_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1645_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1646_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1647_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1648_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1649_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1650_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1651_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1652_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1653_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1654_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1655_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1656_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1657_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1658_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1659_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1660_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1661_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1662_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1663_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1664_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1665_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1666_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1667_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1668_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1669_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1670_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1671_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1672_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1673_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1674_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1675_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1676_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1677_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1678_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1679_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1680_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1681_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1682_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1683_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1684_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1685_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1686_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1687_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1688_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1689_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1690_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1691_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1692_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1693_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1694_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1695_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1696_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1697_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1698_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1699_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1700_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1701_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1702_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1703_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1704_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1705_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1706_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1707_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1708_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1709_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1710_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1711_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1712_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1713_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1714_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1715_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1716_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1717_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1718_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1719_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1720_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1721_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1722_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1723_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1724_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1725_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1726_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1727_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1728_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1729_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1730_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1731_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1732_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1733_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1734_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1735_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1736_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1737_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1738_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1739_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1740_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1741_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1742_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1743_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1744_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1745_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1746_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1747_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1748_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1749_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1750_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1751_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1752_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1753_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1754_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1755_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1756_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1757_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1758_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1759_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1760_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1761_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1762_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1763_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1764_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1765_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1766_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1767_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1768_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1769_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1770_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1771_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1772_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1773_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1774_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1775_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1776_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1777_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1778_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1779_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1780_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1781_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1782_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1783_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1784_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1785_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1786_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1787_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1788_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1789_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1790_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1791_DATA 0b00000000000000000000000000000000 //
#define             DENALI_PHY_1792_DATA 0b00000000000000000000000000000000 // PHY_FREQ_SEL:RW:0:2:=0x00
#define             DENALI_PHY_1793_DATA 0b00000000000000000000000100000000 // PHY_SW_GRP0_SHIFT_0:RW+:24:5:=0x00 PHY_FREQ_SEL_INDEX:RW+:16:2:=0x00 PHY_FREQ_SEL_MULTICAST_EN:RW+:8:1:=0x01 PHY_FREQ_SEL_FROM_REGIF:RW_D:0:1:=0x00
#define             DENALI_PHY_1794_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP0_SHIFT_1:RW+:24:5:=0x00 PHY_SW_GRP3_SHIFT_0:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_0:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_0:RW+:0:5:=0x00
#define             DENALI_PHY_1795_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP0_SHIFT_2:RW+:24:5:=0x00 PHY_SW_GRP3_SHIFT_1:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_1:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_1:RW+:0:5:=0x00
#define             DENALI_PHY_1796_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP0_SHIFT_3:RW+:24:5:=0x00 PHY_SW_GRP3_SHIFT_2:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_2:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_2:RW+:0:5:=0x00
#define             DENALI_PHY_1797_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP0_SHIFT_4:RW+:24:5:=0x00 PHY_SW_GRP3_SHIFT_3:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_3:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_3:RW+:0:5:=0x00
#define             DENALI_PHY_1798_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP0_SHIFT_5:RW+:24:5:=0x00 PHY_SW_GRP3_SHIFT_4:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_4:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_4:RW+:0:5:=0x00
#define             DENALI_PHY_1799_DATA 0b00000000000000000000000000000000 // PHY_SW_GRP3_SHIFT_5:RW+:16:5:=0x00 PHY_SW_GRP2_SHIFT_5:RW+:8:5:=0x00 PHY_SW_GRP1_SHIFT_5:RW+:0:5:=0x00
#define             DENALI_PHY_1800_DATA 0b00000000000001010000000000000000 // PHY_GRP_BYPASS_OVERRIDE:RW:24:1:=0x00 PHY_SW_GRP_BYPASS_SHIFT:RW:16:5:=0x05 PHY_GRP_BYPASS_SLAVE_DELAY:RW:0:11:=0x0000
#define             DENALI_PHY_1801_DATA 0b00000100000000000000000000000000 // PHY_CSLVL_START:RW:16:11:=0x0400 SC_PHY_MANUAL_UPDATE_PHYUPD_ENABLE:RW_D:8:1:=0x00 SC_PHY_MANUAL_UPDATE:WR:0:1:=0x00
#define             DENALI_PHY_1802_DATA 0b00000000000000000000000001010101 // SC_PHY_CSLVL_DEBUG_CONT:WR:24:1:=0x00 PHY_CSLVL_DEBUG_MODE:RW:16:1:=0x00 PHY_CSLVL_COARSE_DLY:RW:0:11:=0x0055
#define             DENALI_PHY_1803_DATA 0b00000000000000000000000000000000 // SC_PHY_CSLVL_ERROR_CLR:WR:0:1:=0x00
#define             DENALI_PHY_1804_DATA 0b00000000000000000000000000000000 // PHY_CSLVL_OBS0:RD:0:32:=0x00000000
#define             DENALI_PHY_1805_DATA 0b00000000000000000000000000000000 // PHY_CSLVL_OBS1:RD:0:32:=0x00000000
#define             DENALI_PHY_1806_DATA 0b00000000000011110000000000000001 // PHY_CSLVL_CS_MAP:RW:16:4:=0x0f PHY_LP4_BOOT_DISABLE:RW:8:1:=0x00 PHY_CSLVL_ENABLE:RW:0:1:=0x01
#define             DENALI_PHY_1807_DATA 0b00000000001010000000000001000000 // PHY_CSLVL_COARSE_CHK:RW:16:11:=0x0028 PHY_CSLVL_QTR:RW:0:11:=0x0040
#define             DENALI_PHY_1808_DATA 0b00000000000000000101000000000010 // PHY_ADRCTL_SNAP_OBS_REGS:WR:24:1:=0x00 PHY_ADRCTL_SLAVE_LOOP_CNT_UPDATE:RW:16:3:=0x00 PHY_CALVL_CS_MAP:RW:8:8:=0x50 PHY_CSLVL_COARSE_CAPTURE_CNT:RW:0:4:=0x02
#define             DENALI_PHY_1809_DATA 0b00000000000000010000000100000001 // PHY_LPDDR3_CS:RW_D:24:1:=0x00 PHY_LP4_ACTIVE:RW:16:1:=0x01 PHY_ADRCTL_LPDDR:RW:8:1:=0x01 PHY_DFI_PHYUPD_TYPE:RW:0:2:=0x01
#define             DENALI_PHY_1810_DATA 0b00000000000000001000000000001000 // PHY_CLK_DC_FREQ_CHG_ADJ:RW:24:1:=0x00 PHY_CLK_DC_WEIGHT:RW:16:2:=0x00 PHY_CLK_DC_CAL_TIMEOUT:RW:8:8:=0x80 PHY_CLK_DC_CAL_SAMPLE_WAIT:RW:0:8:=0x08
#define             DENALI_PHY_1811_DATA 0b00000000000010000001000000100000 // PHY_CLK_DC_ADJUST_DIRECT:RW:24:1:=0x00 PHY_CLK_DC_ADJUST_THRSHLD:RW:16:8:=0x08 PHY_CLK_DC_ADJUST_SAMPLE_CNT:RW:8:8:=0x10 PHY_CLK_DC_ADJUST_START:RW:0:6:=0x20
#define             DENALI_PHY_1812_DATA 0b00000000000000000000000000000000 // PHY_CONTINUOUS_CLK_CAL_UPDATE:RW:24:1:=0x00 SC_PHY_UPDATE_CLK_CAL_VALUES:WR:16:1:=0x00 PHY_CLK_DC_CAL_START:RW+:8:1:=0x00 PHY_CLK_DC_CAL_POLARITY:RW:0:1:=0x00
#define             DENALI_PHY_1813_DATA 0b00000000000000000000000000000000 // PHY_SW_TXIO_CTRL_3:RW:24:4:=0x00 PHY_SW_TXIO_CTRL_2:RW:16:4:=0x00 PHY_SW_TXIO_CTRL_1:RW:8:4:=0x00 PHY_SW_TXIO_CTRL_0:RW:0:4:=0x00
#define             DENALI_PHY_1814_DATA 0b00000001000000000000000000000000 // PHY_CA_SW_TXPWR_CTRL:RW:24:1:=0x01 PHY_MEMCLK_SW_TXIO_CTRL:RW:16:1:=0x00 PHY_SW_TXIO_CTRL_5:RW:8:4:=0x00 PHY_SW_TXIO_CTRL_4:RW:0:4:=0x00
#define             DENALI_PHY_1815_DATA 0b00000000000000000000000000000001 // PHY_MEMCLK_SW_TXPWR_CTRL:RW:0:1:=0x01
#define             DENALI_PHY_1816_DATA 0b00000000000000000000000000000000 // PHY_USER_DEF_REG_AC_0:RW:0:32:=0x00000000
#define             DENALI_PHY_1817_DATA 0b00000000000000000000000000000000 // PHY_USER_DEF_REG_AC_1:RW:0:32:=0x00000000
#define             DENALI_PHY_1818_DATA 0b00000000000000000000000000000000 // PHY_USER_DEF_REG_AC_2:RW:0:32:=0x00000000
#define             DENALI_PHY_1819_DATA 0b00000000000000000000000000000000 // PHY_USER_DEF_REG_AC_3:RW:0:32:=0x00000000
#define             DENALI_PHY_1820_DATA 0b00000000000000000000000000000000 // PHY_LP4_BOOT_PLL_BYPASS:RW:0:1:=0x00
#define             DENALI_PHY_1821_DATA 0b00000000000000000000000000000000 // PHY_CLK_SWITCH_OBS:RD:0:32:=0x00000000
#define             DENALI_PHY_1822_DATA 0b00000000000000000000000001100100 // PHY_PLL_WAIT:RW:0:8:=0x64
#define             DENALI_PHY_1823_DATA 0b00000000000000000000000000000000 // PHY_SW_PLL_BYPASS:RW+:0:1:=0x00
#define             DENALI_PHY_1824_DATA 0b00000000000000000000000000000000 // PHY_SET_DFI_INPUT_3:RW:24:4:=0x00 PHY_SET_DFI_INPUT_2:RW:16:4:=0x00 PHY_SET_DFI_INPUT_1:RW:8:4:=0x00 PHY_SET_DFI_INPUT_0:RW:0:4:=0x00
#define             DENALI_PHY_1825_DATA 0b00000001000000010000000000000000 // PHY_CS_ACS_ALLOCATION_bit1_0:RW:24:4:=0x01 PHY_CS_ACS_ALLOCATION_bit0_0:RW:16:4:=0x01 PHY_SET_DFI_INPUT_5:RW:8:4:=0x00 PHY_SET_DFI_INPUT_4:RW:0:4:=0x00
#define             DENALI_PHY_1826_DATA 0b00000010000000100000000100000001 // PHY_CS_ACS_ALLOCATION_bit1_1:RW:24:4:=0x02 PHY_CS_ACS_ALLOCATION_bit0_1:RW:16:4:=0x02 PHY_CS_ACS_ALLOCATION_bit3_0:RW:8:4:=0x01 PHY_CS_ACS_ALLOCATION_bit2_0:RW:0:4:=0x01
#define             DENALI_PHY_1827_DATA 0b00000100000001000000001000000010 // PHY_CS_ACS_ALLOCATION_bit1_2:RW:24:4:=0x04 PHY_CS_ACS_ALLOCATION_bit0_2:RW:16:4:=0x04 PHY_CS_ACS_ALLOCATION_bit3_1:RW:8:4:=0x02 PHY_CS_ACS_ALLOCATION_bit2_1:RW:0:4:=0x02
#define             DENALI_PHY_1828_DATA 0b00001000000010000000010000000100 // PHY_CS_ACS_ALLOCATION_bit1_3:RW:24:4:=0x08 PHY_CS_ACS_ALLOCATION_bit0_3:RW:16:4:=0x08 PHY_CS_ACS_ALLOCATION_bit3_2:RW:8:4:=0x04 PHY_CS_ACS_ALLOCATION_bit2_2:RW:0:4:=0x04
#define             DENALI_PHY_1829_DATA 0b00001111000011110000100000001000 // PHY_CS_ACS_ALLOCATION_bit1_4:RW:24:4:=0x0f PHY_CS_ACS_ALLOCATION_bit0_4:RW:16:4:=0x0f PHY_CS_ACS_ALLOCATION_bit3_3:RW:8:4:=0x08 PHY_CS_ACS_ALLOCATION_bit2_3:RW:0:4:=0x08
#define             DENALI_PHY_1830_DATA 0b00001111000011110000111100001111 // PHY_CS_ACS_ALLOCATION_bit1_5:RW:24:4:=0x0f PHY_CS_ACS_ALLOCATION_bit0_5:RW:16:4:=0x0f PHY_CS_ACS_ALLOCATION_bit3_4:RW:8:4:=0x0f PHY_CS_ACS_ALLOCATION_bit2_4:RW:0:4:=0x0f
#define             DENALI_PHY_1831_DATA 0b00100000001000000000111100001111 // PHY_CLK_DC_ADJUST_1:RW+:24:8:=0x20 PHY_CLK_DC_ADJUST_0:RW+:16:8:=0x20 PHY_CS_ACS_ALLOCATION_bit3_5:RW:8:4:=0x0f PHY_CS_ACS_ALLOCATION_bit2_5:RW:0:4:=0x0f
#define             DENALI_PHY_1832_DATA 0b00011011010000101000000000000000 // PHY_LP4_BOOT_PLL_CTRL:RW:16:13:=0x1b42 PHY_CLK_DC_DM_THRSHLD:RW+:8:8:=0x80 PHY_CLK_DC_INIT_DISABLE:RW+:0:1:=0x00
#define             DENALI_PHY_1833_DATA 0b00000000000000000000000000000100 // PHY_PLL_OBS_0:RD:16:16:=0x0000 PHY_PLL_CTRL_OVERRIDE:RW:0:16:=0x0004
#define             DENALI_PHY_1834_DATA 0b00000001000000010000000000000000 // PHY_PLL_REFOUT_SEL:RW:24:1:=0x01 PHY_PLL_TESTOUT_SEL:RW:16:1:=0x01 PHY_PLL_OBS_1:RD:0:16:=0x0000
#define             DENALI_PHY_1835_DATA 0b00000001000001110000001100000001 // PHY_LS_IDLE_EN:RW:24:1:=0x01 PHY_LP_WAKEUP:RW:16:8:=0x07 PHY_TCKSRE_WAIT:RW:8:4:=0x03 PHY_LP4_BOOT_LOW_FREQ_SEL:RW:0:1:=0x01
#define             DENALI_PHY_1836_DATA 0b00000000000000000000000001010100 // PHY_TDFI_PHY_WRDELAY:RW:16:1:=0x00 PHY_LP_CTRLUPD_CNTR_CFG:RW:0:10:=0x0054
#define             DENALI_PHY_1837_DATA 0b00000000000000000100010000010000 // PHY_PAD_FDBK_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1838_DATA 0b00000000000000000100010000010000 // PHY_PAD_DATA_TERM:RW+:0:17:=0x004410
#define             DENALI_PHY_1839_DATA 0b00000000000000000100010000010000 // PHY_PAD_DQS_TERM:RW+:0:17:=0x004410
#define             DENALI_PHY_1840_DATA 0b00000000000000000100010000010000 // PHY_PAD_ADDR_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1841_DATA 0b00000000000000000100010000010000 // PHY_PAD_CLK_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1842_DATA 0b00000000000000000100010000010000 // PHY_PAD_ERR_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1843_DATA 0b00000000000000000100010000010000 // PHY_PAD_CKE_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1844_DATA 0b00000000000000000100010000010000 // PHY_PAD_RST_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1845_DATA 0b00000000000000000100010000010000 // PHY_PAD_CS_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1846_DATA 0b00000000000000000100010000010000 // PHY_ADRCTL_RX_CAL:RW:24:7:=0x00 PHY_PAD_ODT_TERM:RW+:0:18:=0x004410
#define             DENALI_PHY_1847_DATA 0b00000000000000000000000000000000 // PHY_ADRCTL_LP3_RX_CAL:RW:0:13:=0x0000
#define             DENALI_PHY_1848_DATA 0b00000000000000000000000000000000 // PHY_TST_CLK_PAD_CTRL:RW:0:32:=0x00000000
#define             DENALI_PHY_1849_DATA 0b00000000000000000000000000000000 // PHY_TST_CLK_PAD_CTRL2:RW:0:23:=0x000000
#define             DENALI_PHY_1850_DATA 0b00000000000000000000000000000000 // PHY_TST_CLK_PAD_CTRL3:RW:0:21:=0x000000
#define             DENALI_PHY_1851_DATA 0b00000000000000000000000000000000 // PHY_TST_CLK_PAD_CTRL4:RW:0:21:=0x000000
#define             DENALI_PHY_1852_DATA 0b00000000000000000000000001100100 // PHY_CAL_START_0:WR:24:1:=0x00 PHY_CAL_CLEAR_0:WR:16:1:=0x00 PHY_CAL_MODE_0:RW:0:13:=0x0064
#define             DENALI_PHY_1853_DATA 0b00000000000000000000000000000000 // PHY_CAL_INTERVAL_COUNT_0:RW:0:32:=0x00000000
#define             DENALI_PHY_1854_DATA 0b00000000000000000000000100001000 // PHY_LP4_BOOT_CAL_CLK_SELECT_0:RW:8:3:=0x01 PHY_CAL_SAMPLE_WAIT_0:RW:0:8:=0x08
#define             DENALI_PHY_1855_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1856_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT2_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1857_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT4_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1858_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT5_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1859_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT6_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1860_DATA 0b00000011000000000000000000000000 // PHY_CAL_CPTR_CNT_0:RW:24:7:=0x03 PHY_CAL_RESULT7_OBS_0:RD:0:24:=0x000000
#define             DENALI_PHY_1861_DATA 0b00000000000000000000000000000000 // PHY_CAL_DBG_CFG_0:RW:24:1:=0x00 PHY_CAL_RCV_FINE_ADJ_0:RW:16:8:=0x00 PHY_CAL_PD_FINE_ADJ_0:RW:8:8:=0x00 PHY_CAL_PU_FINE_ADJ_0:RW:0:8:=0x00
#define             DENALI_PHY_1862_DATA 0b00000000000000000000000000000000 // SC_PHY_PAD_DBG_CONT_0:WR:0:1:=0x00
#define             DENALI_PHY_1863_DATA 0b00000000000000000000000000000000 // PHY_CAL_RESULT3_OBS_0:RD:0:32:=0x00000000
#define             DENALI_PHY_1864_DATA 0b00000100000100000010000000110101 // PHY_CAL_SLOPE_ADJ_0:RW_D:8:20:=0x041020 PHY_ADRCTL_PVT_MAP_0:RW:0:7:=0x35
#define             DENALI_PHY_1865_DATA 0b00000000000001000001000000100000 // PHY_CAL_SLOPE_ADJ_PASS2_0:RW_D:0:20:=0x041020
#define             DENALI_PHY_1866_DATA 0b00000001110010011000110010011000 // PHY_CAL_TWO_PASS_CFG_0:RW_D:0:25:=0x01c98c98
#define             DENALI_PHY_1867_DATA 0b00111111010000000000000000000000 // PHY_CAL_RANGE_PASS1_PU_MAX_DELTA_0:RW_D:24:6:=0x3f PHY_CAL_SW_CAL_CFG_0:RW:0:23:=0x400000
#define             DENALI_PHY_1868_DATA 0b00111111001111110001111100111111 // PHY_CAL_RANGE_PASS2_PD_MAX_DELTA_0:RW_D:24:6:=0x3f PHY_CAL_RANGE_PASS2_PU_MAX_DELTA_0:RW_D:16:6:=0x3f PHY_CAL_RANGE_PASS1_RX_MAX_DELTA_0:RW_D:8:5:=0x1f PHY_CAL_RANGE_PASS1_PD_MAX_DELTA_0:RW_D:0:6:=0x3f
#define             DENALI_PHY_1869_DATA 0b00011111001111110011111100011111 // PHY_CAL_RANGE_PASS1_RX_MIN_DELTA_0:RW:24:5:=0x1f PHY_CAL_RANGE_PASS1_PD_MIN_DELTA_0:RW:16:6:=0x3f PHY_CAL_RANGE_PASS1_PU_MIN_DELTA_0:RW:8:6:=0x3f PHY_CAL_RANGE_PASS2_RX_MAX_DELTA_0:RW_D:0:5:=0x1f
#define             DENALI_PHY_1870_DATA 0b00000000000111110011111100111111 // PHY_CAL_RANGE_PASS2_RX_MIN_DELTA_0:RW:16:5:=0x1f PHY_CAL_RANGE_PASS2_PD_MIN_DELTA_0:RW:8:6:=0x3f PHY_CAL_RANGE_PASS2_PU_MIN_DELTA_0:RW:0:6:=0x3f
#define             DENALI_PHY_1871_DATA 0b00000000000000000000000000000000 // PHY_AC_LPBK_ERR_CLEAR:WR:24:1:=0x00 PHY_ADRCTL_MANUAL_UPDATE:WR:16:1:=0x00 PHY_PAD_ATB_CTRL:RW:0:16:=0x0000
#define             DENALI_PHY_1872_DATA 0b00000000000000000000000000000000 // PHY_AC_LPBK_CONTROL:RW:16:9:=0x0000 PHY_AC_LPBK_ENABLE:RW:8:6:=0x00 PHY_AC_LPBK_OBS_SELECT:RW:0:3:=0x00
#define             DENALI_PHY_1873_DATA 0b00000000000000000000000000000001 // PHY_AC_PRBS_PATTERN_MASK:RW:8:4:=0x00 PHY_AC_PRBS_PATTERN_START:RW_D:0:7:=0x01
#define             DENALI_PHY_1874_DATA 0b00000000000000000000000000000000 // PHY_AC_LPBK_RESULT_OBS:RD:0:32:=0x00000000
#define             DENALI_PHY_1875_DATA 0b00000000000000000000000000000000 // PHY_AC_CLK_LPBK_CONTROL:RW:16:6:=0x00 PHY_AC_CLK_LPBK_ENABLE:RW:8:2:=0x00 PHY_AC_CLK_LPBK_OBS_SELECT:RW:0:1:=0x00
#define             DENALI_PHY_1876_DATA 0b00000000000000000000000000000000 // PHY_TOP_PWR_RDC_DISABLE:RW_D:24:1:=0x00 PHY_AC_PWR_RDC_DISABLE:RW:16:1:=0x00 PHY_AC_CLK_LPBK_RESULT_OBS:RD:0:16:=0x0000
#define             DENALI_PHY_1877_DATA 0b00000000000000000000000000000000 // PHY_AC_SLV_DLY_CTRL_GATE_DISABLE:RW_D:0:1:=0x00
#define             DENALI_PHY_1878_DATA 0b01110110010101000011001000010000 // PHY_DATA_BYTE_ORDER_SEL:RW:0:32:=0x76543210
#define             DENALI_PHY_1879_DATA 0b00000110000000010000000110011000 // PHY_ADR_DISABLE:RW:24:3:=0x06 PHY_CALVL_DEVICE_MAP:RW:16:5:=0x01 PHY_LPDDR4_CONNECT:RW:8:1:=0x01 PHY_DATA_BYTE_ORDER_SEL_HIGH:RW:0:8:=0x98
#define             DENALI_PHY_1880_DATA 0b00000000000000000000000000000000 // PHY_ADRCTL_MSTR_DLY_ENC_SEL:RW:0:2:=0x00
#define             DENALI_PHY_1881_DATA 0b00000000000000000000000000000000 // PHY_DDL_AC_ENABLE:RW:0:32:=0x00000000
#define             DENALI_PHY_1882_DATA 0b00000000000000000000000000000000 // PHY_DDL_AC_MODE:RW:0:26:=0x00000000
#define             DENALI_PHY_1883_DATA 0b00000000000001000000011100000000 // PHY_DDL_TRACK_UPD_THRESHOLD_AC:RW:16:8:=0x04 PHY_INIT_UPDATE_CONFIG:RW:8:3:=0x07 PHY_DDL_AC_MASK:RW:0:6:=0x00
#define             DENALI_PHY_1884_DATA 0b00000000000000000000000000000000 // PHY_ERR_STATUS:RW+:24:3:=0x00 PHY_ERR_MASK_EN:RW:16:3:=0x00 PHY_CA_PARITY_ERR_PULSE_MIN:RW:0:16:=0x0000
#define             DENALI_PHY_1885_DATA 0b00000000000000000000000000000000 // PHY_DS0_DQS_ERR_COUNTER:RW+:0:32:=0x00000000
#define             DENALI_PHY_1886_DATA 0b00000000000000000000000000000000 // PHY_DS1_DQS_ERR_COUNTER:RW+:0:32:=0x00000000
#define             DENALI_PHY_1887_DATA 0b00000000000000000000000000000000 // PHY_DS2_DQS_ERR_COUNTER:RW+:0:32:=0x00000000
#define             DENALI_PHY_1888_DATA 0b00000000000000000000000000000000 // PHY_DS3_DQS_ERR_COUNTER:RW+:0:32:=0x00000000
#define             DENALI_PHY_1889_DATA 0b00000000000000000000000000000010 // PHY_DS_INIT_COMPLETE_OBS:RD:24:4:=0x00 PHY_AC_INIT_COMPLETE_OBS:RD:8:14:=0x0000 PHY_DLL_RST_EN:RW_D:0:2:=0x02
#define             DENALI_PHY_1890_DATA 0b00000000000000000000000000000000 // PHY_GRP_SLV_DLY_ENC_OBS_SELECT:RW:24:6:=0x00 PHY_AC_DCC_RXCAL_CTRL_GATE_DISABLE:RW_D:16:1:=0x00 PHY_ERR_IE:RW:8:1:=0x00 PHY_UPDATE_MASK:RW:0:1:=0x00
#define             DENALI_PHY_1891_DATA 0b00000000000000000000000000000000 // PHY_GRP_SHIFT_OBS:RD:24:3:=0x00 PHY_GRP_SLV_DLY_ENC_OBS:RD:8:11:=0x0000 PHY_GRP_SHIFT_OBS_SELECT:RW:0:5:=0x00
#define             DENALI_PHY_1892_DATA 0b00000000000000000000000000000000 // PHY_PAD_CAL_IO_CFG_0:RW+:0:18:=0x000000
#define             DENALI_PHY_1893_DATA 0b00000000000000000000000000000000 // PHY_PAD_ACS_IO_CFG:RW+:0:19:=0x000000
#define             DENALI_PHY_1894_DATA 0b00000000000000000000000000000000 // PHY_PLL_BYPASS:RW+:0:1:=0x00
#define             DENALI_PHY_1895_DATA 0b00000000000000000001000101000010 // PHY_LOW_FREQ_SEL:RW+:16:1:=0x00 PHY_PLL_CTRL:RW+:0:13:=0x1142
#define             DENALI_PHY_1896_DATA 0b00000011000000100000000100000000 // PHY_CSLVL_DLY_STEP:RW+:24:4:=0x03 PHY_CSLVL_CAPTURE_CNT:RW+:16:4:=0x02 PHY_PAD_VREF_CTRL_AC:RW:0:10:=0x0100
#define             DENALI_PHY_1897_DATA 0b00000011000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_0:RW+:16:11:=0x0300 PHY_GRP0_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1898_DATA 0b00000011000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_0:RW+:16:11:=0x0300 PHY_GRP2_SLAVE_DELAY_0:RW+:0:11:=0x0300
#define             DENALI_PHY_1899_DATA 0b00000011000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_1:RW+:16:11:=0x0300 PHY_GRP0_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1900_DATA 0b00000011000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_1:RW+:16:11:=0x0300 PHY_GRP2_SLAVE_DELAY_1:RW+:0:11:=0x0300
#define             DENALI_PHY_1901_DATA 0b00000011000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_2:RW+:16:11:=0x0300 PHY_GRP0_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1902_DATA 0b00000011000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_2:RW+:16:11:=0x0300 PHY_GRP2_SLAVE_DELAY_2:RW+:0:11:=0x0300
#define             DENALI_PHY_1903_DATA 0b00000011000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_3:RW+:16:11:=0x0300 PHY_GRP0_SLAVE_DELAY_3:RW+:0:11:=0x0300
#define             DENALI_PHY_1904_DATA 0b00000011000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_3:RW+:16:11:=0x0300 PHY_GRP2_SLAVE_DELAY_3:RW+:0:11:=0x0300
#define             DENALI_PHY_1905_DATA 0b00000011000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_4:RW+:16:11:=0x0300 PHY_GRP0_SLAVE_DELAY_4:RW+:0:11:=0x0300
#define             DENALI_PHY_1906_DATA 0b00000011000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_4:RW+:16:11:=0x0300 PHY_GRP2_SLAVE_DELAY_4:RW+:0:11:=0x0300
#define             DENALI_PHY_1907_DATA 0b00000000000000000000001100000000 // PHY_GRP0_SLAVE_DELAY_5:RW+:0:11:=0x0300
#define             DENALI_PHY_1908_DATA 0b00000000000000000000001100000000 // PHY_GRP1_SLAVE_DELAY_5:RW+:0:11:=0x0300
#define             DENALI_PHY_1909_DATA 0b00000000000000000000001100000000 // PHY_GRP2_SLAVE_DELAY_5:RW+:0:11:=0x0300
#define             DENALI_PHY_1910_DATA 0b00000000000000000000001100000000 // PHY_GRP3_SLAVE_DELAY_5:RW+:0:11:=0x0300
#define             DENALI_PHY_1911_DATA 0b00000000000000000000000000000010 // PHY_CLK_DC_CAL_CLK_SEL:RW+:0:3:=0x02
#define             DENALI_PHY_1912_DATA 0b00000000000000000100000000010001 // PHY_PAD_FDBK_DRIVE:RW+:0:28:=0x00004011
#define             DENALI_PHY_1913_DATA 0b00000000000000000100000000010001 // PHY_PAD_FDBK_DRIVE2:RW+:0:16:=0x4011
#define             DENALI_PHY_1914_DATA 0b00000000000000000000000001000000 // PHY_PAD_DATA_DRIVE:RW+:0:30:=0x00000040
#define             DENALI_PHY_1915_DATA 0b00000000000000000000000001000000 // PHY_PAD_DQS_DRIVE:RW+:0:28:=0x00000040
#define             DENALI_PHY_1916_DATA 0b00000000000000000100000000010001 // PHY_PAD_ADDR_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1917_DATA 0b00000000000111111111111100000000 // PHY_PAD_ADDR_DRIVE2:RW+:0:22:=0x1fff00
#define             DENALI_PHY_1918_DATA 0b00000000000000000100000000010001 // PHY_PAD_CLK_DRIVE:RW+:0:31:=0x00004011
#define             DENALI_PHY_1919_DATA 0b00000000000000000100000000010001 // PHY_PAD_CLK_DRIVE2:RW+:0:17:=0x004011
#define             DENALI_PHY_1920_DATA 0b00000000000000000100000000010001 // PHY_PAD_ERR_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1921_DATA 0b00000000000000000100000000010001 // PHY_PAD_ERR_DRIVE2:RW+:0:22:=0x004011
#define             DENALI_PHY_1922_DATA 0b00000000000000000100000000010001 // PHY_PAD_CKE_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1923_DATA 0b00000000000000000100000000010001 // PHY_PAD_CKE_DRIVE2:RW+:0:22:=0x004011
#define             DENALI_PHY_1924_DATA 0b00000000000000000100000000010001 // PHY_PAD_RST_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1925_DATA 0b00000000000000000100000000010001 // PHY_PAD_RST_DRIVE2:RW+:0:29:=0x00004011
#define             DENALI_PHY_1926_DATA 0b00000000000000000100000000010001 // PHY_PAD_CS_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1927_DATA 0b00000000000000000100000000010001 // PHY_PAD_CS_DRIVE2:RW+:0:22:=0x004011
#define             DENALI_PHY_1928_DATA 0b00000000000000000100000000010001 // PHY_PAD_ODT_DRIVE:RW+:0:29:=0x00004011
#define             DENALI_PHY_1929_DATA 0b00000001000000000100000000010001 // PHY_CAL_CLK_SELECT_0:RW+:24:3:=0x01 PHY_PAD_ODT_DRIVE2:RW+:0:22:=0x004011
#define             DENALI_PHY_1930_DATA 0b00000000001000000000010000000000 // PHY_CAL_SETTLING_PRD_0:RW+:16:7:=0x20 PHY_CAL_VREF_SWITCH_TIMER_0:RW+:0:16:=0x0400
//* ********************************************************
//* The below are used only for simulation phy purposes.
//* Please ignore if using integrated Cadence PHY.
//* SimulationValues {{{
//* ********************************************************
#define SIM_PHY_VALS_DEFINED 1 // Global define for simulation
#define                        SMALL_TREF_ENABLE 0x0 // CTL
#define                                  MR8_VAL 0x10 // CTL
#define                                  MR0_VAL 0x0 // CTL
#define                          MR0_RL3_SUPPORT 0x0 // CTL
#define                            ODT_RD_TIMING 0x0 // CTL
#define                                  TAC_MIN 0x0 // CTL
#define                                  TAC_MAX 0x0 // CTL
#define               LPDDR1_PD_CLK_GATE_DISABLE 0x0 // CTL
#define                          LPDDR1_ATTACHED 0x0 // CTL
//* ********************************************************
//* SimulationValues }}}
//* ********************************************************
